/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 24 "vhd2vl.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>
#include "def.h"

int yylex(void);
void yyerror(const char *s);

int vlog_ver=0;  /* default is -g1995 */

/* You will of course want to tinker with this if you use a debugging
 * malloc(), otherwise all the line numbers will point here.
 */
void *xmalloc(size_t size) {
	void *p = malloc(size);
	if (!p) {
		perror("malloc");
		exit(2);
	}
	return p;
}

int skipRem = 0;
int lineno=1;

sglist *io_list=NULL;
sglist *sig_list=NULL;
sglist *type_list=NULL;
blknamelist *blkname_list=NULL;

/* need a stack of clock-edges because all edges are processed before all processes are processed.
 * Edges are processed in source file order, processes are processed in reverse source file order.
 * The original scheme of just one clkedge variable makes all clocked processes have the edge sensitivity
 * of the last clocked process in the file.
 */
int clkedges[MAXEDGES];
int clkptr = 0;
int delay=1;
int dolist=1;
int np=1;
char wire[]="wire";
char reg[]="reg";
int dowith=0;
slist *slwith;

/* Indentation variables */
int indent=0;
slist *indents[MAXINDENT];

struct vrange *new_vrange(enum vrangeType t)
{
  struct vrange *v=xmalloc(sizeof(vrange));
  v->vtype=t;
  v->nlo = NULL;
  v->nhi = NULL;
  v->size_expr = NULL;
  v->sizeval = 0;
  v->xlo = NULL;
  v->xhi = NULL;
  return v;
}

void fslprint(FILE *fp,slist *sl){
  if(sl){
    assert(sl != sl->slst);
    fslprint(fp,sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      fslprint(fp,sl->data.sl);
      break;
    case 1 : case 4 :
      fprintf(fp,"%s",sl->data.txt);
      break;
    case 2 :
      fprintf(fp,"%d",sl->data.val);
      break;
    case 3 :
      fprintf(fp,"%s",*(sl->data.ptxt));
      break;
    }
  }
}

void slprint(slist *sl){
  fslprint(stdout, sl);
}

slist *copysl(slist *sl){
  if(sl){
    slist *newsl;
    newsl = xmalloc(sizeof(slist));
    *newsl = *sl;
    if (sl->slst != NULL) {
      assert(sl != sl->slst);
      newsl->slst = copysl(sl->slst);
    }
    switch(sl->type){
    case 0 :
      if (sl->data.sl != NULL) {
        assert(sl != sl->data.sl);
        newsl->data.sl = copysl(sl->data.sl);
      }
      break;
    case 1 : case 4 :
      newsl->data.txt = xmalloc(strlen(sl->data.txt) + 1);
      strcpy(newsl->data.txt, sl->data.txt);
      break;
    }
    return newsl;
  }
  return NULL;
}

slist *addtxt(slist *sl, const char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 1;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addothers(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 4;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addptxt(slist *sl, char **s){
  slist *p;

  if(s == NULL)
    return sl;

  p = xmalloc(sizeof *p);
  p->type = 3;
  p->slst = sl;
  p->data.ptxt = s;

  return p;
}

slist *addval(slist *sl, int val){
  slist *p;

  p = xmalloc(sizeof(slist));
  p->type = 2;
  p->slst = sl;
  p->data.val = val;

  return p;
}

slist *addsl(slist *sl, slist *sl2){
  slist *p;
  if(sl2 == NULL) return sl;
  p = xmalloc(sizeof(slist));
  p->type = 0;
  p->slst = sl;
  p->data.sl = sl2;
  return p;
}

slist *addvec(slist *sl, char *s){
  sl=addval(sl,strlen(s));
  sl=addtxt(sl,"'b ");
  sl=addtxt(sl,s);
  return sl;
}

slist *addvec_base(slist *sl, char *b, char *s){
  const char *base_str="'b ";
  int base_mult=1;
  if (strcasecmp(b,"X") == 0) {
     base_str="'h "; base_mult=4;
  } else if (strcasecmp(b,"O") == 0) {
     base_str="'o "; base_mult=3;
  } else {
     fprintf(stderr,"Warning on line %d: NAME STRING rule matched but "
       "NAME='%s' is not X or O.\n",lineno, b);
  }
  sl=addval(sl,strlen(s)*base_mult);
  sl=addtxt(sl,base_str);
  sl=addtxt(sl,s);
  return sl;
}

slist *addind(slist *sl){
  if(sl)
    sl=addsl(indents[indent],sl);
  return sl;
}

slist *addpar(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl," [");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"] ");
  } else {
    sl=addtxt(sl," ");
  }
  return sl;
}

slist *addpar_snug(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

/* This function handles array of vectors in signal lists */
slist *addpar_snug2(slist *sl, vrange *v, vrange *v1){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  if(v1->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v1->nhi != NULL){
      sl=addsl(sl,v1->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v1->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addpost(slist *sl, vrange *v){
  if(v->xlo != NULL) {
    sl=addtxt(sl,"[");
    if(v->xhi != NULL){
      sl=addsl(sl,v->xhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->xlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addwrap(const char *l,slist *sl,const char *r){
slist *s;
  s=addtxt(NULL,l);
  s=addsl(s,sl);
  return addtxt(s,r);
}

expdata *addnest(struct expdata *inner)
{
  expdata *e;
  e=xmalloc(sizeof(expdata));
  if (inner->op == 'c') {
    e->sl=addwrap("{",inner->sl,"}");
  } else {
    e->sl=addwrap("(",inner->sl,")");
  }
  return e;
}

slist *addrem(slist *sl, slist *rem)
{
  if (rem) {
    sl=addtxt(sl, "  ");
    sl=addsl(sl, rem);
  } else {
    sl=addtxt(sl, "\n");
  }
  return sl;
}

sglist *lookup(sglist *sg,char *s){
  for(;;){
    if(sg == NULL || strcmp(sg->name,s)==0)
      return sg;
    sg=sg->next;
  }
}

char *sbottom(slist *sl){
  while(sl->slst != NULL)
    sl=sl->slst;
  return sl->data.txt;
}

const char *inout_string(int type)
{
  const char *name=NULL;
  switch(type) {
    case 0: name="input"  ; break;
    case 1: name="output" ; break;
    case 2: name="inout"  ; break;
    default: break;
  }
  return name;
}

int prec(int op){
  switch(op){
  case 'o': /* others */
    return 9;
    break;
  case 't':case 'n':
    return 8;
    break;
  case '~':
    return 7;
    break;
  case 'p': case 'm':
    return 6;
    break;
  case '*': case '/': case '%':
    return 5;
    break;
  case '+': case '-':
    return 4;
    break;
  case '&':
    return 3;
    break;
  case '^':
    return 2;
    break;
  case '|':
    return 1;
    break;
   default:
    return 0;
    break;
  }
}

expdata *addexpr(expdata *expr1,int op,const char* opstr,expdata *expr2){
slist *sl1,*sl2;
  if(expr1 == NULL)
    sl1=NULL;
  else if(expr1->op == 'c')
    sl1=addwrap("{",expr1->sl,"}");
  else if(prec(expr1->op) < prec(op))
    sl1=addwrap("(",expr1->sl,")");
  else
    sl1=expr1->sl;

  if(expr2->op == 'c')
    sl2=addwrap("{",expr2->sl,"}");
  else if(prec(expr2->op) < prec(op))
    sl2=addwrap("(",expr2->sl,")");
  else
    sl2=expr2->sl;

  if(expr1 == NULL)
    expr1=expr2;
  else
    free(expr2);

  expr1->op=op;
  sl1=addtxt(sl1,opstr);
  sl1=addsl(sl1,sl2);
  expr1->sl=sl1;
  return expr1;
}

void slTxtReplace(slist *sl, const char *match, const char *replace){
  if(sl){
    slTxtReplace(sl->slst, match, replace);
    switch(sl->type) {
    case 0 :
      slTxtReplace(sl->data.sl, match, replace);
      break;
    case 1 :
      if (strcmp(sl->data.txt, match) == 0) {
        sl->data.txt = strdup(replace);
      }
      break;
    case 3 :
      if (strcmp(*(sl->data.ptxt), match) == 0) {
        *(sl->data.ptxt) = strdup(replace);
      }
      break;
    }
  }
}


/* XXX todo: runtime engage clkedge debug */
void push_clkedge(int val, const char *comment)
{
  if (0) fprintf(stderr,"clock event push: line=%d clkptr=%d, value=%d (%s)\n",lineno,clkptr,val,comment);
  clkedges[clkptr++]=val;
  assert(clkptr < MAXEDGES);
}

int pull_clkedge(slist *sensitivities)
{
  int clkedge;
  assert(clkptr>0);
  clkedge = clkedges[--clkptr];
  if (0) {
     fprintf(stderr,"clock event pull: value=%d, sensistivity list = ", clkedge);
     fslprint(stderr,sensitivities);
     fprintf(stderr,"\n");
  }
  return clkedge;
}

/* XXX maybe it's a bug that some uses don't munge clocks? */
slist *add_always(slist *sl, slist *sensitivities, slist *decls, int munge)
{
           int clkedge;
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"always @(");
           if (munge) {
             clkedge = pull_clkedge(sensitivities);
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               /* traverse $4->sl replacing " or " with " or posedge " if there is a clockedge */
               slTxtReplace(sensitivities," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace(sensitivities," or ", " or negedge ");
             }
           }
           sl=addsl(sl,sensitivities);
           sl=addtxt(sl,") begin");
           if(decls){
             sl=addtxt(sl," : P");
             sl=addval(sl,np++);
             sl=addtxt(sl,"\n");
             sl=addsl(sl,decls);
           }
           sl=addtxt(sl,"\n");
           return sl;
}

void fixothers(slist *size_expr, slist *sl) {
  if(sl) {
    fixothers(size_expr, sl->slst);
    switch(sl->type) {
    case 0 :
      fixothers(size_expr,sl->data.sl);
      break;
    case 4 : {
      /* found an (OTHERS => 'x') clause - change to type 0, and insert the
       * size_expr for the corresponding signal */
      slist *p;
      slist *size_copy = xmalloc(sizeof(slist));
      size_copy = copysl(size_expr);
      if (0) {
        fprintf(stderr,"fixothers type 4 size_expr ");
        fslprint(stderr,size_expr);
        fprintf(stderr,"\n");
      }
      p = addtxt(NULL, "1'b");
      p = addtxt(p, sl->data.txt);
      p = addwrap("{",p,"}");
      p = addsl(size_copy, p);
      p = addwrap("{",p,"}");
      sl->type=0;
      sl->slst=p;
      sl->data.sl=NULL;
      break;
    } /* case 4 */
    } /* switch */
  }
}

void findothers(slval *sgin,slist *sl){
  sglist *sg = NULL;
  int size = -1;
  int useExpr=0;
  if (0) {
    fprintf(stderr,"findothers lhs ");
    fslprint(stderr,sgin->sl);
    fprintf(stderr,", sgin->val %d\n", sgin->val);
  }
  if(sgin->val>0) {
    size=sgin->val;
  } else if (sgin->range != NULL) {
    if (sgin->range->vtype != tVRANGE) {
      size=1;
    } else if (sgin->range->sizeval > 0) {
      size=sgin->range->sizeval;
    } else if (sgin->range->size_expr != NULL) {
      useExpr = 1;
      fixothers(sgin->range->size_expr, sl);
    }
  } else {
    if((sg=lookup(io_list,sgin->sl->data.txt))==NULL) {
      sg=lookup(sig_list,sgin->sl->data.txt);
    }
    if(sg) {
      if(sg->range->vtype != tVRANGE) {
        size=1;
      } else {
        if (sg->range->sizeval > 0) {
          size = sg->range->sizeval;
        } else {
          assert (sg->range->size_expr != NULL);
          useExpr = 1;
          fixothers(sg->range->size_expr, sl);
        }
      }
    } else {
      /* lookup failed, there was no vrange or size value in sgin - so just punt, and assign size=1 */
      size=1;
    }  /* if(sg) */
  }
  if (!useExpr) {
    slist *p;
    assert(size>0);
    /* use size */
    p = addval(NULL,size);
    fixothers(p,sl);
  }
}

/* code to find bit number of the msb of n */
int find_msb(int n)
{
    int k=0;
    if(n&0xff00){
        k|=8;
        n&=0xff00;
    }
    if(n&0xf0f0){
        k|=4;
        n&=0xf0f0;
    }
    if(n&0xcccc){
        k|=2;
        n&=0xcccc;
    }
    if(n&0xaaaa){
        k|=1;
        n&=0xaaaa;
    }
    return k;
}

static char time_unit[2]="\0\0", new_unit[2]="\0\0";
static void set_timescale(const char *s)
{
    if (0) fprintf(stderr,"set_timescale (%s)\n", s);
    new_unit[0] = time_unit[0];
         if (strcasecmp(s,"ms") == 0) { new_unit[0] = 'm'; }
    else if (strcasecmp(s,"us") == 0) { new_unit[0] = 'u'; }
    else if (strcasecmp(s,"ns") == 0) { new_unit[0] = 'n'; }
    else if (strcasecmp(s,"ps") == 0) { new_unit[0] = 'p'; }
    else {
        fprintf(stderr,"Warning on line %d: AFTER NATURAL NAME pattern"
               " matched, but NAME='%s' should be a time unit.\n",lineno,s);
    }
    if (new_unit[0] != time_unit[0]) {
        if (time_unit[0] != 0) {
            fprintf(stderr,"Warning on line %d: inconsistent time unit (%s) ignored\n", lineno, s);
        } else {
            time_unit[0] = new_unit[0];
        }
    }
}

slist *output_timescale(slist *sl)
{
    if (time_unit[0] != 0) {
        sl = addtxt(sl, "`timescale 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s / 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s\n");
    } else {
        sl = addtxt(sl, "// no timescale needed\n");
    }
    return sl;
}

slist *setup_port(sglist *s_list, int dir, vrange *type) {
  slist *sl;
  sglist *p;
  if (vlog_ver == 1) {
    sl=addtxt(NULL,NULL);
  }
  else {
    sl=addtxt(NULL,inout_string(dir));
    sl=addpar(sl,type);
  }
  p=s_list;
  for(;;){
    p->type=wire;
    if (vlog_ver == 1) p->dir=inout_string(dir);
    p->range=type;
    if (vlog_ver == 0) sl=addtxt(sl, p->name);
    if(p->next==NULL)
      break;
    p=p->next;
    if (vlog_ver == 0) sl=addtxt(sl,", ");
  }
  if (vlog_ver == 0) sl=addtxt(sl,";\n");
  p->next=io_list;
  io_list=s_list;
  return sl;
}

slist *emit_io_list(slist *sl)
{
              sglist *p;
              sl=addtxt(sl,"(\n");
              p=io_list;
              for(;;){
                if (vlog_ver == 1) {
                  sl=addtxt(sl,p->dir);
                  sl=addtxt(sl," ");
                  sl=addptxt(sl,&(p->type));
                  sl=addpar(sl,p->range);
                }
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              return sl;
}

#line 732 "vhd2vl.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "vhd2vl.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_REM = 3,                        /* REM  */
  YYSYMBOL_ENTITY = 4,                     /* ENTITY  */
  YYSYMBOL_IS = 5,                         /* IS  */
  YYSYMBOL_PORT = 6,                       /* PORT  */
  YYSYMBOL_GENERIC = 7,                    /* GENERIC  */
  YYSYMBOL_IN = 8,                         /* IN  */
  YYSYMBOL_OUT = 9,                        /* OUT  */
  YYSYMBOL_INOUT = 10,                     /* INOUT  */
  YYSYMBOL_MAP = 11,                       /* MAP  */
  YYSYMBOL_INTEGER = 12,                   /* INTEGER  */
  YYSYMBOL_BIT = 13,                       /* BIT  */
  YYSYMBOL_BITVECT = 14,                   /* BITVECT  */
  YYSYMBOL_DOWNTO = 15,                    /* DOWNTO  */
  YYSYMBOL_TO = 16,                        /* TO  */
  YYSYMBOL_TYPE = 17,                      /* TYPE  */
  YYSYMBOL_END = 18,                       /* END  */
  YYSYMBOL_ARCHITECTURE = 19,              /* ARCHITECTURE  */
  YYSYMBOL_COMPONENT = 20,                 /* COMPONENT  */
  YYSYMBOL_OF = 21,                        /* OF  */
  YYSYMBOL_ARRAY = 22,                     /* ARRAY  */
  YYSYMBOL_SIGNAL = 23,                    /* SIGNAL  */
  YYSYMBOL_BEGN = 24,                      /* BEGN  */
  YYSYMBOL_NOT = 25,                       /* NOT  */
  YYSYMBOL_WHEN = 26,                      /* WHEN  */
  YYSYMBOL_WITH = 27,                      /* WITH  */
  YYSYMBOL_EXIT = 28,                      /* EXIT  */
  YYSYMBOL_SELECT = 29,                    /* SELECT  */
  YYSYMBOL_OTHERS = 30,                    /* OTHERS  */
  YYSYMBOL_PROCESS = 31,                   /* PROCESS  */
  YYSYMBOL_VARIABLE = 32,                  /* VARIABLE  */
  YYSYMBOL_CONSTANT = 33,                  /* CONSTANT  */
  YYSYMBOL_IF = 34,                        /* IF  */
  YYSYMBOL_THEN = 35,                      /* THEN  */
  YYSYMBOL_ELSIF = 36,                     /* ELSIF  */
  YYSYMBOL_ELSE = 37,                      /* ELSE  */
  YYSYMBOL_CASE = 38,                      /* CASE  */
  YYSYMBOL_FOR = 39,                       /* FOR  */
  YYSYMBOL_LOOP = 40,                      /* LOOP  */
  YYSYMBOL_GENERATE = 41,                  /* GENERATE  */
  YYSYMBOL_AFTER = 42,                     /* AFTER  */
  YYSYMBOL_AND = 43,                       /* AND  */
  YYSYMBOL_OR = 44,                        /* OR  */
  YYSYMBOL_XOR = 45,                       /* XOR  */
  YYSYMBOL_MOD = 46,                       /* MOD  */
  YYSYMBOL_LASTVALUE = 47,                 /* LASTVALUE  */
  YYSYMBOL_EVENT = 48,                     /* EVENT  */
  YYSYMBOL_POSEDGE = 49,                   /* POSEDGE  */
  YYSYMBOL_NEGEDGE = 50,                   /* NEGEDGE  */
  YYSYMBOL_STRING = 51,                    /* STRING  */
  YYSYMBOL_NAME = 52,                      /* NAME  */
  YYSYMBOL_RANGE = 53,                     /* RANGE  */
  YYSYMBOL_NULLV = 54,                     /* NULLV  */
  YYSYMBOL_OPEN = 55,                      /* OPEN  */
  YYSYMBOL_CONVFUNC_1 = 56,                /* CONVFUNC_1  */
  YYSYMBOL_CONVFUNC_2 = 57,                /* CONVFUNC_2  */
  YYSYMBOL_BASED = 58,                     /* BASED  */
  YYSYMBOL_FLOAT = 59,                     /* FLOAT  */
  YYSYMBOL_LEFT = 60,                      /* LEFT  */
  YYSYMBOL_NATURAL = 61,                   /* NATURAL  */
  YYSYMBOL_62_ = 62,                       /* '='  */
  YYSYMBOL_ORL = 63,                       /* ORL  */
  YYSYMBOL_ANDL = 64,                      /* ANDL  */
  YYSYMBOL_XNOR = 65,                      /* XNOR  */
  YYSYMBOL_66_ = 66,                       /* '<'  */
  YYSYMBOL_67_ = 67,                       /* '>'  */
  YYSYMBOL_BIGEQ = 68,                     /* BIGEQ  */
  YYSYMBOL_LESSEQ = 69,                    /* LESSEQ  */
  YYSYMBOL_NOTEQ = 70,                     /* NOTEQ  */
  YYSYMBOL_EQUAL = 71,                     /* EQUAL  */
  YYSYMBOL_72_ = 72,                       /* '+'  */
  YYSYMBOL_73_ = 73,                       /* '-'  */
  YYSYMBOL_74_ = 74,                       /* '&'  */
  YYSYMBOL_75_ = 75,                       /* '*'  */
  YYSYMBOL_76_ = 76,                       /* '/'  */
  YYSYMBOL_UMINUS = 77,                    /* UMINUS  */
  YYSYMBOL_UPLUS = 78,                     /* UPLUS  */
  YYSYMBOL_NOTL = 79,                      /* NOTL  */
  YYSYMBOL_80_ = 80,                       /* '('  */
  YYSYMBOL_81_ = 81,                       /* ')'  */
  YYSYMBOL_82_ = 82,                       /* ';'  */
  YYSYMBOL_83_ = 83,                       /* ':'  */
  YYSYMBOL_84_ = 84,                       /* '\''  */
  YYSYMBOL_85_ = 85,                       /* ','  */
  YYSYMBOL_86_ = 86,                       /* '|'  */
  YYSYMBOL_YYACCEPT = 87,                  /* $accept  */
  YYSYMBOL_trad = 88,                      /* trad  */
  YYSYMBOL_rem = 89,                       /* rem  */
  YYSYMBOL_remlist = 90,                   /* remlist  */
  YYSYMBOL_opt_is = 91,                    /* opt_is  */
  YYSYMBOL_opt_entity = 92,                /* opt_entity  */
  YYSYMBOL_opt_architecture = 93,          /* opt_architecture  */
  YYSYMBOL_opt_begin = 94,                 /* opt_begin  */
  YYSYMBOL_generate = 95,                  /* generate  */
  YYSYMBOL_endgenerate = 96,               /* endgenerate  */
  YYSYMBOL_norem = 97,                     /* norem  */
  YYSYMBOL_yesrem = 98,                    /* yesrem  */
  YYSYMBOL_entity = 99,                    /* entity  */
  YYSYMBOL_genlist = 100,                  /* genlist  */
  YYSYMBOL_portlist = 101,                 /* portlist  */
  YYSYMBOL_dir = 102,                      /* dir  */
  YYSYMBOL_type = 103,                     /* type  */
  YYSYMBOL_vec_range = 104,                /* vec_range  */
  YYSYMBOL_updown = 105,                   /* updown  */
  YYSYMBOL_architecture = 106,             /* architecture  */
  YYSYMBOL_doindent = 107,                 /* doindent  */
  YYSYMBOL_unindent = 108,                 /* unindent  */
  YYSYMBOL_a_decl = 109,                   /* a_decl  */
  YYSYMBOL_opt_generic = 110,              /* opt_generic  */
  YYSYMBOL_nolist = 111,                   /* nolist  */
  YYSYMBOL_yeslist = 112,                  /* yeslist  */
  YYSYMBOL_s_list = 113,                   /* s_list  */
  YYSYMBOL_a_body = 114,                   /* a_body  */
  YYSYMBOL_oname = 115,                    /* oname  */
  YYSYMBOL_optname = 116,                  /* optname  */
  YYSYMBOL_gen_optname = 117,              /* gen_optname  */
  YYSYMBOL_edge = 118,                     /* edge  */
  YYSYMBOL_yeswith = 119,                  /* yeswith  */
  YYSYMBOL_with_list = 120,                /* with_list  */
  YYSYMBOL_with_item = 121,                /* with_item  */
  YYSYMBOL_p_decl = 122,                   /* p_decl  */
  YYSYMBOL_p_body = 123,                   /* p_body  */
  YYSYMBOL_elsepart = 124,                 /* elsepart  */
  YYSYMBOL_cases = 125,                    /* cases  */
  YYSYMBOL_wlist = 126,                    /* wlist  */
  YYSYMBOL_wvalue = 127,                   /* wvalue  */
  YYSYMBOL_sign_list = 128,                /* sign_list  */
  YYSYMBOL_sigvalue = 129,                 /* sigvalue  */
  YYSYMBOL_nodelay = 130,                  /* nodelay  */
  YYSYMBOL_delay = 131,                    /* delay  */
  YYSYMBOL_map_list = 132,                 /* map_list  */
  YYSYMBOL_map_item = 133,                 /* map_item  */
  YYSYMBOL_mvalue = 134,                   /* mvalue  */
  YYSYMBOL_generic_map_list = 135,         /* generic_map_list  */
  YYSYMBOL_generic_map_item = 136,         /* generic_map_item  */
  YYSYMBOL_signal = 137,                   /* signal  */
  YYSYMBOL_expr = 138,                     /* expr  */
  YYSYMBOL_exprc = 139,                    /* exprc  */
  YYSYMBOL_conf = 140,                     /* conf  */
  YYSYMBOL_simple_expr = 141               /* simple_expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1143

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  87
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  55
/* YYNRULES -- Number of rules.  */
#define YYNRULES  181
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  650

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   326


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    74,    84,
      80,    81,    75,    72,    85,    73,     2,    76,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    83,    82,
      66,    62,    67,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    86,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    63,    64,    65,
      68,    69,    70,    71,    77,    78,    79
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   757,   757,   772,   780,   791,   792,   795,   796,   802,
     802,   804,   804,   806,   806,   808,   808,   810,   812,   815,
     816,   820,   847,   878,   899,   921,   941,   962,   975,   988,
    1002,  1017,  1018,  1019,  1022,  1025,  1031,  1036,  1037,  1051,
    1089,  1093,  1108,  1109,  1113,  1123,  1126,  1129,  1130,  1153,
    1178,  1187,  1227,  1240,  1248,  1249,  1257,  1258,  1261,  1274,
    1289,  1291,  1303,  1316,  1344,  1357,  1377,  1386,  1401,  1428,
    1457,  1482,  1521,  1560,  1561,  1564,  1565,  1567,  1568,  1580,
    1581,  1584,  1587,  1590,  1595,  1597,  1598,  1606,  1625,  1646,
    1647,  1667,  1691,  1693,  1707,  1726,  1739,  1761,  1783,  1798,
    1804,  1814,  1815,  1825,  1834,  1843,  1850,  1853,  1854,  1861,
    1862,  1863,  1866,  1867,  1875,  1891,  1895,  1908,  1911,  1912,
    1918,  1922,  1931,  1932,  1942,  1943,  1944,  1945,  1946,  1947,
    1956,  1960,  1967,  1972,  1982,  1996,  2020,  2042,  2050,  2057,
    2063,  2069,  2094,  2100,  2107,  2116,  2117,  2118,  2119,  2120,
    2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2139,  2143,
    2146,  2152,  2153,  2156,  2161,  2166,  2174,  2191,  2208,  2225,
    2242,  2259,  2278,  2286,  2293,  2301,  2317,  2320,  2323,  2326,
    2329,  2336
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "REM", "ENTITY", "IS",
  "PORT", "GENERIC", "IN", "OUT", "INOUT", "MAP", "INTEGER", "BIT",
  "BITVECT", "DOWNTO", "TO", "TYPE", "END", "ARCHITECTURE", "COMPONENT",
  "OF", "ARRAY", "SIGNAL", "BEGN", "NOT", "WHEN", "WITH", "EXIT", "SELECT",
  "OTHERS", "PROCESS", "VARIABLE", "CONSTANT", "IF", "THEN", "ELSIF",
  "ELSE", "CASE", "FOR", "LOOP", "GENERATE", "AFTER", "AND", "OR", "XOR",
  "MOD", "LASTVALUE", "EVENT", "POSEDGE", "NEGEDGE", "STRING", "NAME",
  "RANGE", "NULLV", "OPEN", "CONVFUNC_1", "CONVFUNC_2", "BASED", "FLOAT",
  "LEFT", "NATURAL", "'='", "ORL", "ANDL", "XNOR", "'<'", "'>'", "BIGEQ",
  "LESSEQ", "NOTEQ", "EQUAL", "'+'", "'-'", "'&'", "'*'", "'/'", "UMINUS",
  "UPLUS", "NOTL", "'('", "')'", "';'", "':'", "'\\''", "','", "'|'",
  "$accept", "trad", "rem", "remlist", "opt_is", "opt_entity",
  "opt_architecture", "opt_begin", "generate", "endgenerate", "norem",
  "yesrem", "entity", "genlist", "portlist", "dir", "type", "vec_range",
  "updown", "architecture", "doindent", "unindent", "a_decl",
  "opt_generic", "nolist", "yeslist", "s_list", "a_body", "oname",
  "optname", "gen_optname", "edge", "yeswith", "with_list", "with_item",
  "p_decl", "p_body", "elsepart", "cases", "wlist", "wvalue", "sign_list",
  "sigvalue", "nodelay", "delay", "map_list", "map_item", "mvalue",
  "generic_map_list", "generic_map_item", "signal", "expr", "exprc",
  "conf", "simple_expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-424)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-77)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      68,    68,    33,    51,  -424,  -424,  -424,    28,    38,    68,
      68,    78,    84,    88,  -424,   113,    66,    68,  -424,   134,
     149,  -424,    80,    86,    68,    68,    68,  -424,   124,   124,
     240,    29,   154,   105,   165,   132,   209,   223,   124,  -424,
     239,    68,  -424,   211,   122,   213,   367,   304,   307,   241,
      68,   248,   124,    68,   267,  -424,   256,  -424,    26,    68,
    -424,  -424,  -424,   122,     8,  -424,    68,   122,    30,   323,
     314,   155,   122,  -424,   355,   737,   238,    68,   311,  -424,
     353,    42,   298,   124,   374,   186,   331,   737,   138,   324,
     380,   313,   768,   331,   312,  -424,   326,   737,  -424,    18,
     329,  -424,   354,   737,   737,   262,  -424,   852,  -424,   163,
     336,  -424,   318,   338,  -424,   164,   124,   737,   419,    68,
     388,  -424,   238,   358,  -424,   436,    68,   400,   389,   417,
     857,   238,    69,   445,  -424,   446,   331,   768,   578,  1062,
     289,  -424,   496,   465,   428,   737,  -424,  -424,   737,  -424,
    -424,  -424,   470,   952,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   202,   318,   194,   415,  -424,
    -424,  -424,   318,   318,   318,   318,   318,  -424,    19,  -424,
     446,   124,   737,   453,   454,   459,  -424,  -424,   737,   478,
      68,   460,    68,    68,  -424,   461,   463,   464,  -424,  -424,
     940,    -9,   737,   643,   695,   712,   524,   768,   768,  -424,
     737,   737,    68,   965,   282,   483,  -424,  1067,   135,   381,
     398,   357,   177,   -32,   -32,   -32,  -424,  -424,  -424,  -424,
     448,   493,  -424,   229,   229,  -424,  -424,   376,    68,  -424,
     473,  -424,   152,   535,    68,    68,   480,   870,    68,  -424,
     484,   309,  -424,  -424,    68,   331,  -424,   440,   737,   440,
     737,   440,   737,  -424,  -424,   295,   295,    68,   157,   893,
     124,  -424,   -15,   514,  -424,   124,  -424,    68,  -424,   122,
    -424,   124,    68,    68,  -424,   331,   238,   555,   568,   737,
    -424,   548,   307,  -424,   440,   440,   440,  -424,   737,   737,
      68,   500,   501,   502,   507,  -424,   124,   505,   508,   124,
    -424,   737,   527,   509,   515,   518,  -424,  1028,   124,   570,
     581,  1022,  1022,  -424,   519,  -424,  -424,  -424,  -424,    68,
     523,   525,  -424,   538,  -424,  -424,  -424,    68,   546,    14,
     528,  -424,   571,   446,  -424,  -424,    68,  -424,    68,   531,
      68,   737,    68,    68,  -424,   579,   768,  -424,   122,    68,
    -424,   540,    68,    68,   605,  -424,    68,   614,    68,   221,
    1028,   442,    68,   786,   552,  -424,    31,   261,   690,   616,
      68,  -424,  -424,   419,   618,   588,  -424,  -424,    68,   615,
    -424,    -2,  -424,  -424,   613,   559,  -424,  -424,   564,     5,
     561,  1067,  -424,  -424,  -424,    68,   585,   567,   386,   331,
     331,   572,   569,   622,  -424,   581,   581,   446,   635,   574,
     737,   107,  -424,   594,   600,    68,   582,   598,    68,   660,
     737,  -424,   737,    68,   589,   590,    64,   335,   636,   121,
     670,   669,    68,   617,   612,   446,   446,   446,   601,   446,
    -424,  -424,   602,  -424,   629,   596,  -424,   506,   621,  -424,
    -424,   737,  -424,   678,  -424,   905,   752,  -424,   638,   639,
     644,   620,    -5,    68,  -424,   810,    68,   737,  -424,  -424,
     631,   624,   628,   632,  -424,   637,  -424,  -424,   352,    52,
    -424,   645,    68,  1067,   642,    68,   768,   646,   649,   654,
    -424,   699,    68,    77,   705,   834,   737,   737,  -424,    68,
      68,  -424,  -424,   651,  -424,  -424,  -424,   127,  -424,  -424,
     768,   700,  -424,   685,   116,   717,   737,   737,   917,  -424,
      68,  -424,  -424,    68,  -424,    68,  -424,   295,   658,   377,
    -424,   674,   -39,   703,  1004,  1016,  -424,    68,  -424,  -424,
     662,    68,   727,   386,   714,   731,   683,   686,   673,  -424,
    -424,    68,  -424,   676,  -424,   728,   725,   170,   386,    68,
     732,  -424,  -424,    68,    68,    68,  -424,  -424,   424,   446,
    -424,  -424,   726,   421,  -424,   688,    68,    68,  -424,  -424,
    -424,    68,   768,  -424,   694,    68,    68,  -424,  -424,    68,
    -424,  -424,   754,   759,  -424,   237,  -424,  -424,  -424,    68,
    -424,  -424,   705,   738,   739,    68,   763,   424,  -424,  -424,
     701,   713,  -424,   765,  -424,   779,    68,    68,   719,   769,
    -424,  -424,   784,   723,   776,   790,   446,   778,   733,   734,
    -424,   795,    68,   783,  -424,   446,   736,  -424,    68,  -424
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     7,     0,     0,     6,     8,     1,     0,     0,     5,
       5,     0,     0,     3,     4,     5,     0,     5,    57,     0,
       0,     2,     0,     0,     5,     5,     5,    47,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,    45,
       0,     5,    58,     0,     0,     0,     0,     0,     9,     0,
       5,     0,     0,     5,    36,    34,     0,    38,     5,     5,
      31,    32,    33,     0,     0,    10,     5,     0,    77,     0,
       0,     0,     0,    59,     0,     0,     0,     5,     0,    26,
       0,     5,     0,     0,    54,     0,     0,     0,   134,     0,
      13,     0,     0,     0,     0,    57,     0,     0,   138,   134,
       0,   139,   140,     0,     0,     0,   137,     0,   173,   134,
       0,   174,     0,     0,   172,    40,     0,     0,    11,     5,
       0,    27,     0,     0,    56,     0,     5,     0,   134,     0,
       0,     0,    78,     0,    14,    73,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,   152,   142,     0,   141,
     146,   145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   134,     0,    37,
      42,    43,     0,     0,     0,     0,     0,    25,     5,    12,
      73,     0,     0,     0,     0,     0,    56,    48,     0,     0,
       5,     0,     5,     5,    74,     0,     0,   112,   152,   165,
       0,     0,     0,     0,     0,     0,    15,     0,     0,    45,
       0,     0,     5,     0,     0,     0,   160,    35,   153,   154,
     155,   151,   156,   147,   148,   144,   149,   150,    41,   175,
       0,     0,   181,   176,   177,   178,   179,    39,     5,    23,
       0,    28,     5,     0,     5,     5,     0,     0,     5,    84,
     135,     0,    19,    46,     5,     0,   162,   166,     0,   169,
       0,   167,     0,    16,    17,   163,   164,     5,     0,     0,
       0,   157,     0,     0,   180,     0,    21,     5,    29,     0,
      51,     0,     5,     5,    19,     0,     0,     0,     0,     0,
      44,    89,     9,   113,   170,   168,   171,    46,     0,     0,
       5,     0,     0,     0,     0,    24,     0,     0,     0,     0,
      49,     0,     0,     0,     0,     0,    20,   118,     0,     0,
       0,     0,     0,    50,     0,   159,   158,   143,    30,     5,
       0,     0,    20,     0,   136,    45,    45,     5,     0,     0,
       0,    45,     0,    73,    45,    45,     5,    52,     5,     0,
       5,     0,     5,     5,    61,     0,     0,   114,     0,     5,
      18,     0,     5,     5,     0,    55,     5,     0,     5,     0,
     118,     0,     5,     0,     0,   119,     0,     0,    92,     0,
       5,    46,    46,    11,     0,     0,    63,    85,     5,     0,
     124,   134,   128,   126,     0,   120,   122,   125,     0,   134,
     130,   132,    46,   117,   115,     5,     0,     0,     0,     0,
       0,     0,    19,     0,    70,     0,     0,    73,     0,     0,
       0,     0,   127,     0,     0,     5,     0,     0,     5,     0,
       0,    90,     0,     5,     0,     0,   134,     0,     0,     0,
       0,     0,     5,     0,     0,    73,    73,    73,     0,    73,
      62,    86,     0,   109,   111,    88,   107,     0,     0,   121,
      46,     0,   131,     0,   116,     0,    92,    99,     0,     0,
       0,     0,     0,     5,    45,     0,     5,     0,   100,    19,
       0,     0,     0,     0,    22,     0,    87,   110,     0,   134,
     123,     0,     5,   133,     0,     5,     0,     0,     0,     0,
      79,     0,     5,   134,   106,     0,     0,     0,    46,     5,
       5,    57,   108,     0,    64,    45,    91,     0,    82,    83,
       0,     0,    46,     0,     0,     0,     0,     0,     0,    20,
       5,    72,    71,     5,   129,     5,    45,    80,     0,   101,
      81,     0,     0,     0,     0,     0,    20,     5,    66,    53,
       0,     5,     0,     0,    45,     0,     0,     0,     0,    45,
      45,     5,    94,     0,    46,     0,     0,     0,     0,     5,
       0,    45,    45,     5,     5,     5,    93,    46,   101,    73,
      45,    45,     0,     0,    46,     0,     5,     5,    98,    46,
      46,     5,     0,    45,     0,     5,     5,    45,   103,     5,
      46,    46,     0,     0,    65,     0,    46,    46,    46,     5,
      95,   105,   106,     0,     0,     5,     0,   101,    46,   104,
       0,     0,    67,     0,   102,     0,     5,     5,     0,     0,
      97,    96,     0,     0,     0,     0,    73,     0,     0,     0,
      46,     0,     5,     0,    68,    73,     0,    46,     5,    69
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -424,  -424,     0,   820,   530,   443,  -424,  -424,   178,    63,
    -273,  -330,  -424,  -112,  -168,  -424,   -60,   -95,  -424,   815,
     -34,    20,  -424,  -424,   647,   -94,   -10,  -251,  -161,  -424,
    -424,  -423,  -424,   403,  -424,  -385,   112,   214,   218,   308,
     348,   584,  -303,  -424,   472,  -404,  -424,   395,   425,  -424,
      11,   414,   -86,  -424,   -23
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,   466,     4,    66,   180,   135,   264,   209,   343,
     289,   337,     9,    32,    34,    63,    58,   113,   176,    10,
     569,   290,    30,   125,   185,    22,    35,    69,   195,    70,
      71,   438,   285,   368,   369,   292,   379,   555,   525,   455,
     456,   196,   316,   430,   339,   372,   395,   396,   374,   400,
     106,   139,   265,   141,   115
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       3,   144,   350,    81,   177,    50,   140,    85,   332,    13,
      14,   311,    94,   241,   471,    19,   297,    21,    33,   240,
     431,   459,     1,   557,    27,    28,    29,   183,    49,     1,
      82,    42,     1,     6,   207,   208,   191,   302,   475,   208,
     356,    52,    73,   163,   164,     1,   303,   488,   -60,   422,
      68,   199,   201,    74,    86,     7,   147,    87,    79,    80,
     423,   -75,   155,   156,   157,   158,    84,   427,   403,   147,
       8,     1,   256,   123,   207,   208,   256,   116,   131,    89,
      11,   121,    88,    15,   159,   131,   354,   114,    83,   168,
      12,   160,   161,   162,   163,   164,   357,   129,   131,   367,
     -76,   238,   301,   422,   142,    16,    33,     8,    77,    78,
     516,   381,   382,   404,    41,   147,     1,   386,    20,   181,
      18,   192,   266,   114,   119,   120,   187,   464,   147,   414,
     566,   550,   131,   114,    54,    55,    56,   452,   328,   444,
      23,   331,   114,   230,   131,   582,   541,   197,   470,   233,
     234,   235,   236,   237,    24,     1,   474,   131,   453,   454,
      25,   523,   536,   305,   475,   208,    26,   453,   454,   308,
     207,   208,   298,   299,    57,   267,    31,   114,   239,   170,
     171,   158,   361,   114,   114,   114,   114,   114,    44,    92,
     249,   313,   251,   252,    93,   155,   156,   157,   158,   547,
     155,   156,   157,   158,   529,   581,   506,   160,   161,   162,
     163,   164,   270,   475,   208,    46,   561,   159,   131,   307,
     155,   132,   159,   158,   160,   161,   162,   163,   164,   160,
     161,   162,   163,   164,   277,    43,   172,   173,   275,   174,
     175,   514,   278,   131,   280,   281,    45,   165,   284,   160,
     161,   162,   163,   164,   291,   228,   448,    36,   531,   532,
      37,    47,   229,    38,    39,    33,   197,    68,   126,   127,
     376,    33,   581,    40,   131,    48,    96,   306,   231,   548,
     207,   208,   309,   310,   481,   482,   483,    97,   485,   108,
     109,    51,   152,    53,   110,    59,   312,   114,   377,   111,
     323,   352,   353,   387,   174,   175,   388,   359,   340,    64,
     362,   363,    65,    98,    99,   287,   288,   320,   112,   100,
      75,   101,   439,   102,    67,   155,   156,   157,   158,   347,
     206,    72,   207,   208,   103,   104,    76,    68,   207,   208,
     604,    90,   105,   405,   406,    91,   364,   159,   365,    96,
      68,   472,   371,   373,   160,   161,   162,   163,   164,   378,
     137,    95,    68,    68,   622,   152,   384,   272,    68,   108,
     167,   118,   398,   117,   110,    60,    61,    62,   122,   111,
      68,   124,   397,   128,   434,   435,    98,   436,   420,   412,
     133,   644,   100,   136,   101,   143,   102,   649,   112,   134,
      96,   415,   416,   453,   454,   291,   145,   103,   104,   148,
     517,   137,   149,   553,   554,   437,   166,   533,   594,   169,
     440,   441,   429,   179,   155,   371,   157,   158,   373,   160,
     161,   162,   163,   164,   537,   434,   435,    98,   436,   184,
     502,   155,   186,   100,   158,   101,   159,   102,   172,   173,
     182,   174,   175,   160,   161,   162,   163,   164,   103,   104,
     592,   593,   188,   159,   475,   208,   437,   567,   397,   131,
     160,   161,   162,   163,   164,   638,   504,   412,   446,   447,
     492,   535,   583,   189,   646,   157,   158,   172,   173,   107,
     174,   175,    68,   390,   391,   291,   232,   392,   194,   344,
     345,   130,   551,   393,   210,   159,   605,   193,   212,    68,
      68,   146,   160,   161,   162,   163,   164,   150,   151,   153,
     172,   173,   394,   174,   175,   574,   575,   211,   530,   274,
      68,   178,   215,   549,   243,   371,   244,   586,   587,   245,
     248,   250,   539,   253,   254,   467,   595,   596,   263,   255,
     273,   198,   200,   229,   478,   276,   279,   390,   489,   213,
     282,   392,   214,   609,   286,   304,   314,   393,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   315,
     318,   324,   325,   326,   578,   501,   394,   329,   327,   330,
     334,    68,    96,   333,   341,   335,   242,   591,   336,   342,
     351,   346,   247,   137,   598,   348,   349,   355,   152,   602,
     603,   358,   360,   366,   522,    68,   257,   259,   261,   227,
     611,   612,   380,   383,   268,   269,   615,   616,   617,    98,
      99,   375,   385,   402,   413,   100,   418,   101,   625,   102,
     419,   421,    68,   424,   425,   426,   428,   432,    68,   433,
     103,   104,   443,   445,   442,   449,   450,    96,   138,   562,
     642,   457,   458,   564,   460,   461,   463,   648,    97,   468,
     469,   473,   294,   576,   295,   476,   296,   477,   480,   479,
     487,   584,   488,   484,   486,   588,   589,   590,   491,   494,
     497,   498,   499,   507,    98,    99,   513,   520,   600,   601,
     100,   500,   101,   317,   102,   258,   508,   607,   608,    96,
     509,   610,   321,   322,   510,   103,   104,   521,   407,   511,
      97,   618,   515,   105,   408,   317,    96,   518,   409,   410,
     519,   524,   534,   540,   538,   543,   556,    97,   630,   631,
     552,   558,   128,   563,   411,   565,    98,    99,   568,   570,
     571,    96,   100,   572,   101,   573,   102,   260,   577,   579,
     580,   597,    97,    98,    99,   370,   585,   103,   104,   100,
     599,   101,   613,   102,   262,   105,   606,   614,   620,   621,
     407,   623,    96,   626,   103,   104,   496,   401,    98,    99,
     409,   410,   105,   137,   100,   627,   101,   629,   102,   628,
      96,   632,   634,   633,   128,   635,   411,   636,   637,   103,
     104,    97,   639,   643,   645,   640,   641,   105,   647,    98,
      99,     5,   319,   451,    96,   100,   417,   101,    17,   102,
     619,   624,   542,   246,   370,   137,   512,    98,   399,   293,
     103,   104,   389,   100,   317,   101,   465,   102,   138,   526,
     527,   200,   490,   462,     0,     0,     0,     0,   103,   104,
       0,    98,   503,     0,     0,     0,   105,   100,   154,   101,
       0,   102,     0,     0,     0,   493,     0,   155,   156,   157,
     158,     0,   103,   104,     0,     0,   190,     0,     0,     0,
     138,   505,     0,     0,     0,   155,   156,   157,   158,   159,
     155,   156,   157,   158,     0,     0,   160,   161,   162,   163,
     164,     0,     0,   155,   156,   157,   158,   159,     0,     0,
     528,   317,   159,     0,   160,   161,   162,   163,   164,   160,
     161,   162,   163,   164,     0,   159,   155,   156,   157,   158,
     544,   545,   160,   161,   162,   163,   164,     0,   155,   156,
     157,   158,   283,     0,     0,     0,     0,     0,   159,     0,
     155,   156,   157,   158,     0,   160,   161,   162,   163,   164,
     159,     0,     0,     0,     0,   300,     0,   160,   161,   162,
     163,   164,   159,   155,   156,   157,   158,   495,     0,   160,
     161,   162,   163,   164,     0,   155,   156,   157,   158,   546,
       0,     0,   202,     0,     0,   159,   203,   204,   155,   156,
     157,   158,   160,   161,   162,   163,   205,   159,     0,     0,
       0,   216,     0,     0,   160,   161,   162,   163,   164,     0,
     159,     0,     0,   216,     0,     0,     0,   160,   161,   162,
     163,   164,     0,     0,   559,     0,   271,   155,   156,   157,
     158,     0,     0,     0,     0,     0,   560,     0,     0,   155,
     156,   157,   158,   206,     0,   155,   156,   157,   158,   159,
     338,   155,   156,   157,   158,     0,   160,   161,   162,   163,
     164,   159,     0,     0,     0,     0,     0,   159,   160,   161,
     162,   163,   164,   159,   160,   161,   162,   163,   164,     0,
     160,   161,   162,   163,   164,   155,   156,   157,   158,     0,
     155,   156,   157,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   202,     0,     0,   159,   203,   204,
       0,     0,   159,     0,   160,   161,   162,   163,   205,   160,
     161,   162,   163,   164
};

static const yytype_int16 yycheck[] =
{
       0,    95,   332,    63,   116,    39,    92,    67,   311,     9,
      10,   284,    72,   181,   437,    15,   267,    17,    28,   180,
     405,   425,     3,    62,    24,    25,    26,   122,    38,     3,
      22,    31,     3,     0,    43,    44,   131,    52,    43,    44,
      26,    41,    52,    75,    76,     3,    61,    86,    18,    51,
      50,   137,   138,    53,    24,     4,    51,    27,    58,    59,
      62,    31,    43,    44,    45,    46,    66,    62,    37,    51,
      19,     3,    81,    83,    43,    44,    81,    77,    80,    68,
      52,    81,    52,     5,    65,    80,   337,    76,    80,   112,
      52,    72,    73,    74,    75,    76,    82,    86,    80,   350,
      31,    82,   270,    51,    93,    21,   116,    19,    82,    83,
     495,   362,   363,    82,    85,    51,     3,   368,    52,   119,
       7,    52,   208,   112,    82,    83,   126,   430,    51,   380,
     553,   535,    80,   122,    12,    13,    14,    30,   306,   412,
       6,   309,   131,   166,    80,   568,    30,   136,    84,   172,
     173,   174,   175,   176,     5,     3,    35,    80,    51,    52,
      80,    84,    35,   275,    43,    44,    80,    51,    52,   281,
      43,    44,    15,    16,    52,   209,    52,   166,   178,    15,
      16,    46,   343,   172,   173,   174,   175,   176,    83,    34,
     190,   286,   192,   193,    39,    43,    44,    45,    46,   529,
      43,    44,    45,    46,   507,    35,   479,    72,    73,    74,
      75,    76,   212,    43,    44,    83,   546,    65,    80,   279,
      43,    83,    65,    46,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76,    82,    81,    72,    73,   238,    75,
      76,   492,   242,    80,   244,   245,    81,    84,   248,    72,
      73,    74,    75,    76,   254,    53,   417,    17,   509,   510,
      20,    52,    60,    23,    24,   275,   255,   267,    82,    83,
     356,   281,    35,    33,    80,    52,    14,   277,    84,   530,
      43,    44,   282,   283,   445,   446,   447,    25,   449,    51,
      52,    52,    30,    82,    56,    82,   285,   286,   358,    61,
     300,   335,   336,    82,    75,    76,    85,   341,   318,     5,
     344,   345,     5,    51,    52,     6,     7,   297,    80,    57,
      53,    59,   408,    61,    83,    43,    44,    45,    46,   329,
      41,    83,    43,    44,    72,    73,    80,   337,    43,    44,
     591,    18,    80,    82,    83,    31,   346,    65,   348,    14,
     350,   437,   352,   353,    72,    73,    74,    75,    76,   359,
      25,     6,   362,   363,   615,    30,   366,    85,   368,    51,
      52,    18,   372,    62,    56,     8,     9,    10,    80,    61,
     380,     7,   371,    52,    49,    50,    51,    52,   388,   378,
      66,   642,    57,    80,    59,    83,    61,   648,    80,    19,
      14,   381,   382,    51,    52,   405,    80,    72,    73,    80,
     496,    25,    58,    36,    37,    80,    80,   511,   579,    81,
     409,   410,   402,     4,    43,   425,    45,    46,   428,    72,
      73,    74,    75,    76,   520,    49,    50,    51,    52,    81,
     474,    43,     6,    57,    46,    59,    65,    61,    72,    73,
      62,    75,    76,    72,    73,    74,    75,    76,    72,    73,
      36,    37,    62,    65,    43,    44,    80,   553,   457,    80,
      72,    73,    74,    75,    76,   636,   476,   466,   415,   416,
     460,   515,   568,    66,   645,    45,    46,    72,    73,    75,
      75,    76,   492,    51,    52,   495,    81,    55,    52,   321,
     322,    87,   536,    61,     8,    65,   592,    62,    80,   509,
     510,    97,    72,    73,    74,    75,    76,   103,   104,   105,
      72,    73,    80,    75,    76,   559,   560,    62,   508,    81,
     530,   117,    62,   533,    81,   535,    82,   571,   572,    80,
      62,    81,   522,    82,    81,   433,   580,   581,    24,    85,
      67,   137,   138,    60,   442,    82,    21,    51,    52,   145,
      80,    55,   148,   597,    80,    51,    11,    61,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    11,
      32,    81,    81,    81,   564,   473,    80,    82,    81,    81,
      81,   591,    14,    66,    24,    80,   182,   577,    80,    18,
      62,    82,   188,    25,   584,    82,    81,    61,    30,   589,
     590,    83,    41,    82,   502,   615,   202,   203,   204,   205,
     600,   601,    82,    18,   210,   211,   606,   607,   608,    51,
      52,    52,    18,    81,    18,    57,    18,    59,   618,    61,
      52,    26,   642,    30,    85,    81,    85,    62,   648,    82,
      72,    73,    83,    31,    82,    20,    82,    14,    80,   547,
     640,    67,    62,   551,    82,    67,     6,   647,    25,    80,
      80,    35,   258,   561,   260,     5,   262,     8,    66,    62,
      51,   569,    86,    82,    82,   573,   574,   575,    67,    11,
      52,    52,    48,    62,    51,    52,    51,    43,   586,   587,
      57,    81,    59,   289,    61,    62,    82,   595,   596,    14,
      82,   599,   298,   299,    82,    72,    73,    18,    28,    82,
      25,   609,    80,    80,    34,   311,    14,    81,    38,    39,
      81,    26,    81,    48,    34,    18,    62,    25,   626,   627,
      82,    38,    52,    81,    54,    18,    51,    52,    34,    18,
      67,    14,    57,    67,    59,    82,    61,    62,    82,    31,
      35,    35,    25,    51,    52,   351,    34,    72,    73,    57,
      82,    59,    18,    61,    62,    80,    82,    18,    40,    40,
      28,    18,    14,    82,    72,    73,    34,   373,    51,    52,
      38,    39,    80,    25,    57,    82,    59,    18,    61,    34,
      14,    82,    18,    34,    52,    82,    54,    31,    18,    72,
      73,    25,    34,    18,    31,    82,    82,    80,    82,    51,
      52,     1,   292,   420,    14,    57,   383,    59,    13,    61,
     612,   617,   524,   186,   420,    25,   488,    51,    52,   255,
      72,    73,   370,    57,   430,    59,   432,    61,    80,    15,
      16,   437,   457,   428,    -1,    -1,    -1,    -1,    72,    73,
      -1,    51,    52,    -1,    -1,    -1,    80,    57,    16,    59,
      -1,    61,    -1,    -1,    -1,   461,    -1,    43,    44,    45,
      46,    -1,    72,    73,    -1,    -1,    29,    -1,    -1,    -1,
      80,   477,    -1,    -1,    -1,    43,    44,    45,    46,    65,
      43,    44,    45,    46,    -1,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    43,    44,    45,    46,    65,    -1,    -1,
     506,   507,    65,    -1,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76,    -1,    65,    43,    44,    45,    46,
     526,   527,    72,    73,    74,    75,    76,    -1,    43,    44,
      45,    46,    82,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      43,    44,    45,    46,    -1,    72,    73,    74,    75,    76,
      65,    -1,    -1,    -1,    -1,    82,    -1,    72,    73,    74,
      75,    76,    65,    43,    44,    45,    46,    82,    -1,    72,
      73,    74,    75,    76,    -1,    43,    44,    45,    46,    82,
      -1,    -1,    62,    -1,    -1,    65,    66,    67,    43,    44,
      45,    46,    72,    73,    74,    75,    76,    65,    -1,    -1,
      -1,    81,    -1,    -1,    72,    73,    74,    75,    76,    -1,
      65,    -1,    -1,    81,    -1,    -1,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    40,    -1,    81,    43,    44,    45,
      46,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    41,    -1,    43,    44,    45,    46,    65,
      42,    43,    44,    45,    46,    -1,    72,    73,    74,    75,
      76,    65,    -1,    -1,    -1,    -1,    -1,    65,    72,    73,
      74,    75,    76,    65,    72,    73,    74,    75,    76,    -1,
      72,    73,    74,    75,    76,    43,    44,    45,    46,    -1,
      43,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    -1,    -1,    65,    66,    67,
      -1,    -1,    65,    -1,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    88,    89,    90,    90,     0,     4,    19,    99,
     106,    52,    52,    89,    89,     5,    21,   106,     7,    89,
      52,    89,   112,     6,     5,    80,    80,    89,    89,    89,
     109,    52,   100,   113,   101,   113,    17,    20,    23,    24,
      33,    85,    89,    81,    83,    81,    83,    52,    52,   113,
     107,    52,    89,    82,    12,    13,    14,    52,   103,    82,
       8,     9,    10,   102,     5,     5,    91,    83,    89,   114,
     116,   117,    83,   113,    89,    53,    80,    82,    83,    89,
      89,   103,    22,    80,    89,   103,    24,    27,    52,   137,
      18,    31,    34,    39,   103,     6,    14,    25,    51,    52,
      57,    59,    61,    72,    73,    80,   137,   138,    51,    52,
      56,    61,    80,   104,   137,   141,    89,    62,    18,    82,
      83,    89,    80,   113,     7,   110,    82,    83,    52,   137,
     138,    80,    83,    66,    19,    93,    80,    25,    80,   138,
     139,   140,   137,    83,   112,    80,   138,    51,    80,    58,
     138,   138,    30,   138,    16,    43,    44,    45,    46,    65,
      72,    73,    74,    75,    76,    84,    80,    52,   141,    81,
      15,    16,    72,    73,    75,    76,   105,   100,   138,     4,
      92,    89,    62,   104,    81,   111,     6,    89,    62,    66,
      29,   104,    52,    62,    52,   115,   128,   137,   138,   139,
     138,   139,    62,    66,    67,    76,    41,    43,    44,    95,
       8,    62,    80,   138,   138,    62,    81,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,    53,    60,
     141,    84,    81,   141,   141,   141,   141,   141,    82,    89,
     115,   101,   138,    81,    82,    80,   111,   138,    62,    89,
      81,    89,    89,    82,    81,    85,    81,   138,    62,   138,
      62,   138,    62,    24,    94,   139,   139,   107,   138,   138,
      89,    81,    85,    67,    81,    89,    82,    82,    89,    21,
      89,    89,    80,    82,    89,   119,    80,     6,     7,    97,
     108,    89,   122,   128,   138,   138,   138,   114,    15,    16,
      82,   101,    52,    61,    51,   100,    89,   103,   100,    89,
      89,    97,   137,   104,    11,    11,   129,   138,    32,    91,
     108,   138,   138,    89,    81,    81,    81,    81,   101,    82,
      81,   101,   129,    66,    81,    80,    80,    98,    42,   131,
     113,    24,    18,    96,    95,    95,    82,    89,    82,    81,
      98,    62,   107,   107,   114,    61,    26,    82,    83,   107,
      41,   115,   107,   107,    89,    89,    82,   114,   120,   121,
     138,    89,   132,    89,   135,    52,   139,   103,    89,   123,
      82,   114,   114,    18,    89,    18,   114,    82,    85,   131,
      51,    52,    55,    61,    80,   133,   134,   137,    89,    52,
     136,   138,    81,    37,    82,    82,    83,    28,    34,    38,
      39,    54,   137,    18,   114,   108,   108,    92,    18,    52,
      89,    26,    51,    62,    30,    85,    81,    62,    85,   108,
     130,   122,    62,    82,    49,    50,    52,    80,   118,   139,
     137,   137,    82,    83,    97,    31,    96,    96,   115,    20,
      82,   120,    30,    51,    52,   126,   127,    67,    62,   132,
      82,    67,   135,     6,   129,   138,    89,   123,    80,    80,
      84,   118,   139,    35,    35,    43,     5,     8,   123,    62,
      66,   115,   115,   115,    82,   115,    82,    51,    86,    52,
     134,    67,   108,   138,    11,    82,    34,    52,    52,    48,
      81,   123,   107,    52,    89,   138,    97,    62,    82,    82,
      82,    82,   127,    51,   114,    80,   122,   139,    81,    81,
      43,    18,   123,    84,    26,   125,    15,    16,   138,   129,
     108,   114,   114,   112,    81,   107,    35,   139,    34,   108,
      48,    30,   126,    18,   138,   138,    82,    98,   114,    89,
     132,   107,    82,    36,    37,   124,    62,    62,    38,    40,
      40,    98,   123,    81,   123,    18,   118,   139,    34,   107,
      18,    67,    67,    82,   107,   107,   123,    82,   108,    31,
      35,    35,   118,   139,   123,    34,   107,   107,   123,   123,
     123,   108,    36,    37,   115,   107,   107,    35,   108,    82,
     123,   123,   108,   108,   114,   139,    82,   123,   123,   107,
     123,   108,   108,    18,    18,   108,   108,   108,   123,   125,
      40,    40,   114,    18,   124,   108,    82,    82,    34,    18,
     123,   123,    82,    34,    18,    82,    31,    18,   115,    34,
      82,    82,   108,    18,   114,    31,   115,    82,   108,   114
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    87,    88,    88,    88,    89,    89,    90,    90,    91,
      91,    92,    92,    93,    93,    94,    94,    95,    96,    97,
      98,    99,    99,   100,   100,   100,   100,   101,   101,   101,
     101,   102,   102,   102,   103,   103,   103,   103,   103,   104,
     104,   104,   105,   105,   106,   107,   108,   109,   109,   109,
     109,   109,   109,   109,   110,   110,   111,   112,   113,   113,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   115,   115,   116,   116,   117,   117,   118,
     118,   118,   118,   118,   119,   120,   120,   120,   121,   122,
     122,   122,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   124,   124,   124,   125,   125,   125,   126,   126,   127,
     127,   127,   128,   128,   129,   129,   129,   130,   131,   131,
     132,   132,   133,   133,   134,   134,   134,   134,   134,   134,
     135,   135,   135,   136,   137,   137,   137,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   139,   139,   139,   139,   139,   140,   140,   140,   140,
     140,   140,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   141
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     3,     3,     0,     1,     1,     2,     0,
       1,     0,     1,     0,     1,     0,     1,     2,     2,     0,
       0,    15,    23,     7,     9,     6,     4,     5,     7,     8,
      10,     1,     1,     1,     1,     5,     1,     4,     1,     3,
       1,     3,     1,     1,    15,     0,     0,     0,     7,    10,
      10,     9,    12,    20,     0,     8,     0,     0,     2,     4,
       1,     9,    13,    11,    15,    21,    16,    23,    31,    35,
      11,    15,    15,     0,     1,     1,     3,     1,     3,     3,
       5,     5,     4,     4,     0,     2,     4,     5,     4,     1,
       7,    10,     1,     9,     8,    12,    15,    15,    10,     4,
       4,     0,     7,     4,     8,     7,     0,     1,     3,     1,
       2,     1,     1,     3,     3,     5,     7,     0,     0,     3,
       2,     4,     1,     4,     1,     1,     1,     2,     1,     6,
       2,     4,     2,     4,     1,     4,     7,     1,     1,     1,
       1,     2,     2,     6,     3,     2,     2,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     4,     6,     6,
       3,     1,     3,     3,     3,     2,     3,     3,     4,     3,
       4,     4,     1,     1,     1,     3,     3,     3,     3,     3,
       4,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* trad: rem entity rem architecture rem  */
#line 757 "vhd2vl.y"
                                        {
        slist *sl;
          sl=output_timescale((yyvsp[-4].sl));
          sl=addsl(sl,(yyvsp[-3].sl));
          sl=addsl(sl,(yyvsp[-2].sl));
          sl=addsl(sl,(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2636 "vhd2vl.tab.c"
    break;

  case 3: /* trad: rem entity rem  */
#line 772 "vhd2vl.y"
                        {
        slist *sl;
          sl=addsl((yyvsp[-2].sl),(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2649 "vhd2vl.tab.c"
    break;

  case 4: /* trad: rem architecture rem  */
#line 780 "vhd2vl.y"
                             {
        slist *sl;
          sl=addsl((yyvsp[-2].sl),(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2662 "vhd2vl.tab.c"
    break;

  case 5: /* rem: %empty  */
#line 791 "vhd2vl.y"
                       {(yyval.sl)=NULL; }
#line 2668 "vhd2vl.tab.c"
    break;

  case 6: /* rem: remlist  */
#line 792 "vhd2vl.y"
                   {(yyval.sl)=(yyvsp[0].sl); }
#line 2674 "vhd2vl.tab.c"
    break;

  case 7: /* remlist: REM  */
#line 795 "vhd2vl.y"
               {(yyval.sl)=addtxt(indents[indent],(yyvsp[0].txt));}
#line 2680 "vhd2vl.tab.c"
    break;

  case 8: /* remlist: REM remlist  */
#line 796 "vhd2vl.y"
                       {
           slist *sl;
           sl=addtxt(indents[indent],(yyvsp[-1].txt));
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 2689 "vhd2vl.tab.c"
    break;

  case 9: /* opt_is: %empty  */
#line 802 "vhd2vl.y"
                       {(yyval.txt)=NULL;}
#line 2695 "vhd2vl.tab.c"
    break;

  case 11: /* opt_entity: %empty  */
#line 804 "vhd2vl.y"
                           {(yyval.txt)=NULL;}
#line 2701 "vhd2vl.tab.c"
    break;

  case 13: /* opt_architecture: %empty  */
#line 806 "vhd2vl.y"
                                 {(yyval.txt)=NULL;}
#line 2707 "vhd2vl.tab.c"
    break;

  case 15: /* opt_begin: %empty  */
#line 808 "vhd2vl.y"
                           {(yyval.txt)=NULL;}
#line 2713 "vhd2vl.tab.c"
    break;

  case 19: /* norem: %empty  */
#line 815 "vhd2vl.y"
                  {skipRem = 1;}
#line 2719 "vhd2vl.tab.c"
    break;

  case 20: /* yesrem: %empty  */
#line 816 "vhd2vl.y"
                   {skipRem = 0;}
#line 2725 "vhd2vl.tab.c"
    break;

  case 21: /* entity: ENTITY NAME IS rem PORT '(' rem portlist ')' ';' rem END opt_entity oname ';'  */
#line 820 "vhd2vl.y"
                                                                                          {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[-13].txt)); /* NAME */
              /* Add the signal list */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[-8].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-7].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                /* sl=addpost(sl,p->range); */
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[-4].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            }
#line 2756 "vhd2vl.tab.c"
    break;

  case 22: /* entity: ENTITY NAME IS GENERIC yeslist '(' rem genlist ')' ';' rem PORT yeslist '(' rem portlist ')' ';' rem END opt_entity oname ';'  */
#line 847 "vhd2vl.y"
                                                                                                                                           {
            slist *sl;
            sglist *p;
              if (0) fprintf(stderr,"matched ENTITY GENERIC\n");
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[-21].txt)); /* NAME */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[-16].sl));  /* rem */
              sl=addsl(sl,(yyvsp[-15].sl));  /* genlist */
              sl=addsl(sl,(yyvsp[-12].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-8].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-7].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[-4].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            }
#line 2789 "vhd2vl.tab.c"
    break;

  case 23: /* genlist: s_list ':' type ':' '=' expr rem  */
#line 878 "vhd2vl.y"
                                            {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-4].v)); /* type */
            p=(yyvsp[-6].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[-1].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2814 "vhd2vl.tab.c"
    break;

  case 24: /* genlist: s_list ':' type ':' '=' expr ';' rem genlist  */
#line 899 "vhd2vl.y"
                                                        {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-6].v)); /* type */
            p=(yyvsp[-8].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[-3].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[-1].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2840 "vhd2vl.tab.c"
    break;

  case 25: /* genlist: s_list ':' type ';' rem genlist  */
#line 921 "vhd2vl.y"
                                           {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-3].v)); /* type */
            p=(yyvsp[-5].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[-1].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2864 "vhd2vl.tab.c"
    break;

  case 26: /* genlist: s_list ':' type rem  */
#line 941 "vhd2vl.y"
                                {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-1].v)); /* type */
            p=(yyvsp[-3].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2887 "vhd2vl.tab.c"
    break;

  case 27: /* portlist: s_list ':' dir type rem  */
#line 962 "vhd2vl.y"
                                    {
            slist *sl;

              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[-4].sg),(yyvsp[-2].n),(yyvsp[-1].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[0].sl));
                free((yyvsp[-1].v));
              }
            }
#line 2904 "vhd2vl.tab.c"
    break;

  case 28: /* portlist: s_list ':' dir type ';' rem portlist  */
#line 975 "vhd2vl.y"
                                                 {
            slist *sl;

              if(dolist){
                sl=setup_port((yyvsp[-6].sg),(yyvsp[-4].n),(yyvsp[-3].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[-1].sl));
                free((yyvsp[-3].v));
              }
            }
#line 2921 "vhd2vl.tab.c"
    break;

  case 29: /* portlist: s_list ':' dir type ':' '=' expr rem  */
#line 988 "vhd2vl.y"
                                                 {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[-7].sg),(yyvsp[-5].n),(yyvsp[-4].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[0].sl));
                free((yyvsp[-4].v));
              }
            }
#line 2939 "vhd2vl.tab.c"
    break;

  case 30: /* portlist: s_list ':' dir type ':' '=' expr ';' rem portlist  */
#line 1002 "vhd2vl.y"
                                                              {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                sl=setup_port((yyvsp[-9].sg),(yyvsp[-7].n),(yyvsp[-6].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[-1].sl));
                free((yyvsp[-6].v));
              }
            }
#line 2957 "vhd2vl.tab.c"
    break;

  case 31: /* dir: IN  */
#line 1017 "vhd2vl.y"
                 { (yyval.n)=0;}
#line 2963 "vhd2vl.tab.c"
    break;

  case 32: /* dir: OUT  */
#line 1018 "vhd2vl.y"
                  { (yyval.n)=1; }
#line 2969 "vhd2vl.tab.c"
    break;

  case 33: /* dir: INOUT  */
#line 1019 "vhd2vl.y"
                    { (yyval.n)=2; }
#line 2975 "vhd2vl.tab.c"
    break;

  case 34: /* type: BIT  */
#line 1022 "vhd2vl.y"
                  {
                (yyval.v)=new_vrange(tSCALAR);
              }
#line 2983 "vhd2vl.tab.c"
    break;

  case 35: /* type: INTEGER RANGE expr TO expr  */
#line 1025 "vhd2vl.y"
                                         {
                fprintf(stderr,"Warning on line %d: integer range ignored\n",lineno);
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              }
#line 2994 "vhd2vl.tab.c"
    break;

  case 36: /* type: INTEGER  */
#line 1031 "vhd2vl.y"
                      {
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              }
#line 3004 "vhd2vl.tab.c"
    break;

  case 37: /* type: BITVECT '(' vec_range ')'  */
#line 1036 "vhd2vl.y"
                                        {(yyval.v)=(yyvsp[-1].v);}
#line 3010 "vhd2vl.tab.c"
    break;

  case 38: /* type: NAME  */
#line 1037 "vhd2vl.y"
                   {
              sglist *sg;

                sg=lookup(type_list,(yyvsp[0].txt));
                if(sg)
                  (yyval.v)=sg->range;
                else{
                  fprintf(stderr,"Undefined type '%s' on line %d\n",(yyvsp[0].txt),lineno);
                  YYABORT;
                }
              }
#line 3026 "vhd2vl.tab.c"
    break;

  case 39: /* vec_range: simple_expr updown simple_expr  */
#line 1051 "vhd2vl.y"
                                           {
              (yyval.v)=new_vrange(tVRANGE);
              (yyval.v)->nhi=(yyvsp[-2].e)->sl;
              (yyval.v)->nlo=(yyvsp[0].e)->sl;
              (yyval.v)->sizeval = -1; /* undefined size */
              /* calculate the width of this vrange */
              if ((yyvsp[-2].e)->op == 'n' && (yyvsp[0].e)->op == 'n') {
                if ((yyvsp[-1].n)==-1) { /* (nhi:natural downto nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[-2].e)->value - (yyvsp[0].e)->value + 1;
                } else {      /* (nhi:natural to     nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[0].e)->value - (yyvsp[-2].e)->value + 1;
                }
              } else {
                /* make an expression to calculate the width of this vrange:
                 * create an expression that calculates:
                 *   size expr = (simple_expr1) - (simple_expr2) + 1
                 */
                expdata *size_expr1  = xmalloc(sizeof(expdata));
                expdata *size_expr2  = xmalloc(sizeof(expdata));
                expdata *diff12  = xmalloc(sizeof(expdata));
                expdata *plusone = xmalloc(sizeof(expdata));
                expdata *finalexpr = xmalloc(sizeof(expdata));
                size_expr1->sl = addwrap("(",(yyvsp[-2].e)->sl,")");
                size_expr2->sl = addwrap("(",(yyvsp[0].e)->sl,")");
                plusone->op='t';
                plusone->sl=addtxt(NULL,"1");
                if ((yyvsp[-1].n)==-1) {
                  /* (simple_expr1 downto simple_expr1) */
                  diff12 = addexpr(size_expr1,'-',"-",size_expr2);
                } else {
                  /* (simple_expr1   to   simple_expr1) */
                  diff12 = addexpr(size_expr2,'-',"-",size_expr1);
                }
                finalexpr = addexpr(diff12,'+',"+",plusone);
                finalexpr->sl = addwrap("(",finalexpr->sl,")");
                (yyval.v)->size_expr = finalexpr->sl;
              }
            }
#line 3069 "vhd2vl.tab.c"
    break;

  case 40: /* vec_range: simple_expr  */
#line 1089 "vhd2vl.y"
                        {
              (yyval.v)=new_vrange(tSUBSCRIPT);
              (yyval.v)->nlo=(yyvsp[0].e)->sl;
          }
#line 3078 "vhd2vl.tab.c"
    break;

  case 41: /* vec_range: NAME '\'' RANGE  */
#line 1093 "vhd2vl.y"
                            {
              /* lookup NAME and copy its vrange */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[-2].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[-2].txt));
              }
              if(sg) {
                (yyval.v) = sg->range;
              } else {
                fprintf(stderr,"Undefined range \"%s'range\" on line %d\n",(yyvsp[-2].txt),lineno);
                YYABORT;
              }
          }
#line 3096 "vhd2vl.tab.c"
    break;

  case 42: /* updown: DOWNTO  */
#line 1108 "vhd2vl.y"
                {(yyval.n)=-1;}
#line 3102 "vhd2vl.tab.c"
    break;

  case 43: /* updown: TO  */
#line 1109 "vhd2vl.y"
            {(yyval.n)=1;}
#line 3108 "vhd2vl.tab.c"
    break;

  case 44: /* architecture: ARCHITECTURE NAME OF NAME IS rem a_decl BEGN doindent a_body END opt_architecture oname ';' unindent  */
#line 1114 "vhd2vl.y"
                                                                            {
               slist *sl;
                 sl=addsl((yyvsp[-9].sl),(yyvsp[-8].sl));
                 sl=addtxt(sl,"\n");
                 (yyval.sl)=addsl(sl,(yyvsp[-5].sl));
               }
#line 3119 "vhd2vl.tab.c"
    break;

  case 45: /* doindent: %empty  */
#line 1123 "vhd2vl.y"
                       {indent= indent < MAXINDENT ? indent + 1 : indent;}
#line 3125 "vhd2vl.tab.c"
    break;

  case 46: /* unindent: %empty  */
#line 1126 "vhd2vl.y"
                       {indent= indent > 0 ? indent - 1 : indent;}
#line 3131 "vhd2vl.tab.c"
    break;

  case 47: /* a_decl: %empty  */
#line 1129 "vhd2vl.y"
            {(yyval.sl)=NULL;}
#line 3137 "vhd2vl.tab.c"
    break;

  case 48: /* a_decl: a_decl SIGNAL s_list ':' type ';' rem  */
#line 1130 "vhd2vl.y"
                                                  {
            sglist *sg;
            slist *sl;

              sl=(yyvsp[-6].sl);
              sg=(yyvsp[-4].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[-2].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[-2].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[-2].v));
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[-4].sg);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 3165 "vhd2vl.tab.c"
    break;

  case 49: /* a_decl: a_decl SIGNAL s_list ':' type ':' '=' expr ';' rem  */
#line 1153 "vhd2vl.y"
                                                               {
            sglist *sg;
            slist *sl;

              sl=(yyvsp[-9].sl);
              sg=(yyvsp[-7].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[-5].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[-5].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[-5].v));
                sl=addtxt(sl," = ");
                sl=addsl(sl,(yyvsp[-2].e)->sl);
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[-7].sg);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 3195 "vhd2vl.tab.c"
    break;

  case 50: /* a_decl: a_decl CONSTANT NAME ':' type ':' '=' expr ';' rem  */
#line 1178 "vhd2vl.y"
                                                               {
            slist * sl;
              sl=addtxt((yyvsp[-9].sl),"parameter ");
              sl=addtxt(sl,(yyvsp[-7].txt));
              sl=addtxt(sl," = ");
              sl=addsl(sl,(yyvsp[-2].e)->sl);
              sl=addtxt(sl,";");
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 3209 "vhd2vl.tab.c"
    break;

  case 51: /* a_decl: a_decl TYPE NAME IS '(' s_list ')' ';' rem  */
#line 1187 "vhd2vl.y"
                                                       {
            slist *sl, *sl2;
            sglist *p;
            int n,k;
              n=0;
              sl=NULL;
              p=(yyvsp[-3].sg);
              for(;;){
                sl=addtxt(sl,"  ");
                sl=addtxt(sl,p->name);
                sl=addtxt(sl," = ");
                sl=addval(sl,n++);
                p=p->next;
                if(p==NULL){
                  sl=addtxt(sl,";\n");
                  break;
                } else
                  sl=addtxt(sl,",\n");
              }
              n--;
              k=find_msb(n);
              sl2=addtxt(NULL,"parameter [");
              sl2=addval(sl2,k);
              sl2=addtxt(sl2,":0]\n");
              sl=addsl(sl2,sl);
              sl=addsl((yyvsp[-8].sl),sl);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[-6].txt);
              if(k>0) {
                p->range=new_vrange(tVRANGE);
                p->range->sizeval = k+1;
                p->range->nhi=addval(NULL,k);
                p->range->nlo=addtxt(NULL,"0");
              } else {
                p->range=new_vrange(tSCALAR);
              }
              p->next=type_list;
              type_list=p;
            }
#line 3254 "vhd2vl.tab.c"
    break;

  case 52: /* a_decl: a_decl TYPE NAME IS ARRAY '(' vec_range ')' OF type ';' rem  */
#line 1227 "vhd2vl.y"
                                                                        {
            slist *sl=NULL;
            sglist *p;
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[-9].txt);
              p->range=(yyvsp[-2].v);
              p->range->xhi=(yyvsp[-5].v)->nhi;
              p->range->xlo=(yyvsp[-5].v)->nlo;
              p->next=type_list;
              type_list=p;
            }
#line 3271 "vhd2vl.tab.c"
    break;

  case 53: /* a_decl: a_decl COMPONENT NAME opt_is rem opt_generic PORT nolist '(' rem portlist ')' ';' rem END COMPONENT oname ';' yeslist rem  */
#line 1240 "vhd2vl.y"
                                                                                                                                       {
              (yyval.sl)=addsl((yyvsp[-19].sl),(yyvsp[0].sl)); /* a_decl, rem4 */
              free((yyvsp[-17].txt)); /* NAME */
              free((yyvsp[-10].sl)); /* rem2 */
              free((yyvsp[-6].sl));/* rem3 */
            }
#line 3282 "vhd2vl.tab.c"
    break;

  case 54: /* opt_generic: %empty  */
#line 1248 "vhd2vl.y"
                          {(yyval.txt)=NULL;}
#line 3288 "vhd2vl.tab.c"
    break;

  case 55: /* opt_generic: GENERIC nolist '(' rem genlist ')' ';' rem  */
#line 1249 "vhd2vl.y"
                                                       {
             if (0) fprintf(stderr,"matched opt_generic\n");
             free((yyvsp[-4].sl));  /* rem */
             free((yyvsp[0].sl));  /* rem */
             (yyval.txt)=NULL;
            }
#line 3299 "vhd2vl.tab.c"
    break;

  case 56: /* nolist: %empty  */
#line 1257 "vhd2vl.y"
                   {dolist = 0;}
#line 3305 "vhd2vl.tab.c"
    break;

  case 57: /* yeslist: %empty  */
#line 1258 "vhd2vl.y"
                    {dolist = 1;}
#line 3311 "vhd2vl.tab.c"
    break;

  case 58: /* s_list: NAME rem  */
#line 1261 "vhd2vl.y"
                  {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[-1].txt);
             sg->next=NULL;
             (yyval.sg)=sg;
           } else{
             free((yyvsp[-1].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[0].sl));
         }
#line 3329 "vhd2vl.tab.c"
    break;

  case 59: /* s_list: NAME ',' rem s_list  */
#line 1274 "vhd2vl.y"
                             {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[-3].txt);
             sg->next=(yyvsp[0].sg);
             (yyval.sg)=sg;
           } else{
             free((yyvsp[-3].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[-1].sl));
         }
#line 3347 "vhd2vl.tab.c"
    break;

  case 60: /* a_body: rem  */
#line 1289 "vhd2vl.y"
             {(yyval.sl)=addind((yyvsp[0].sl));}
#line 3353 "vhd2vl.tab.c"
    break;

  case 61: /* a_body: rem signal '<' '=' rem norem sigvalue yesrem a_body  */
#line 1291 "vhd2vl.y"
                                                             {
         slist *sl;
           sl=addsl((yyvsp[-8].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[-7].ss)->sl);
           findothers((yyvsp[-7].ss),(yyvsp[-2].sl));
           free((yyvsp[-7].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-2].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3370 "vhd2vl.tab.c"
    break;

  case 62: /* a_body: rem BEGN signal '<' '=' rem norem sigvalue yesrem a_body END NAME ';'  */
#line 1303 "vhd2vl.y"
                                                                               {
         slist *sl;
           sl=addsl((yyvsp[-12].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[-10].ss)->sl);
           findothers((yyvsp[-10].ss),(yyvsp[-5].sl));
           free((yyvsp[-10].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-5].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[-3].sl));
         }
#line 3387 "vhd2vl.tab.c"
    break;

  case 63: /* a_body: rem WITH expr SELECT rem yeswith signal '<' '=' with_list a_body  */
#line 1316 "vhd2vl.y"
                                                                          {
         slist *sl;
         sglist *sg;
         char *s;
           sl=addsl((yyvsp[-10].sl),indents[indent]);
           sl=addtxt(sl,"always @(*) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  case(");
           sl=addsl(sl,(yyvsp[-8].e)->sl);
           free((yyvsp[-8].e));
           sl=addtxt(sl,")\n");
           if((yyvsp[-6].sl))
             sl=addsl(sl,(yyvsp[-6].sl));
           s=sbottom((yyvsp[-4].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           findothers((yyvsp[-4].ss),(yyvsp[-1].sl));
           free((yyvsp[-4].ss));
           sl=addsl(sl,(yyvsp[-1].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  endcase\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3419 "vhd2vl.tab.c"
    break;

  case 64: /* a_body: rem NAME ':' NAME rem PORT MAP '(' doindent map_list rem ')' ';' unindent a_body  */
#line 1344 "vhd2vl.y"
                                                                                          {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[-11].txt)); /* NAME2 */
           sl=addtxt(sl," ");
           sl=addtxt(sl,(yyvsp[-13].txt)); /* NAME1 */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));  /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3436 "vhd2vl.tab.c"
    break;

  case 65: /* a_body: rem NAME ':' NAME rem GENERIC MAP '(' doindent generic_map_list ')' unindent PORT MAP '(' doindent map_list ')' ';' unindent a_body  */
#line 1357 "vhd2vl.y"
                                                                                                                                             {
         slist *sl;
           sl=addsl((yyvsp[-20].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[-17].txt)); /* NAME2 (component name) */
           if ((yyvsp[-16].sl)) {
             sl=addsl(sl,(yyvsp[-16].sl));
             sl=addsl(sl,indents[indent]);
           }
           sl=addtxt(sl," #(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-11].sl)); /* (generic) map_list */
           sl=addtxt(sl,")\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,(yyvsp[-19].txt)); /* NAME1 (instance name) */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-4].sl)); /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3461 "vhd2vl.tab.c"
    break;

  case 66: /* a_body: optname PROCESS '(' sign_list ')' p_decl opt_is BEGN doindent p_body END PROCESS oname ';' unindent a_body  */
#line 1377 "vhd2vl.y"
                                                                                                                    {
         slist *sl;
           if (0) fprintf(stderr,"process style 1\n");
           sl=add_always((yyvsp[-15].sl),(yyvsp[-12].sl),(yyvsp[-10].sl),0);
           sl=addsl(sl,(yyvsp[-6].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3475 "vhd2vl.tab.c"
    break;

  case 67: /* a_body: optname PROCESS '(' sign_list ')' p_decl opt_is BEGN doindent rem IF edge THEN p_body END IF ';' END PROCESS oname ';' unindent a_body  */
#line 1387 "vhd2vl.y"
                                                                                    {
           slist *sl;
             if (0) fprintf(stderr,"process style 2: if then end if\n");
             sl=add_always((yyvsp[-22].sl),(yyvsp[-19].sl),(yyvsp[-17].sl),1);
             if((yyvsp[-13].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-13].sl));
             }
             sl=addsl(sl,(yyvsp[-9].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3493 "vhd2vl.tab.c"
    break;

  case 68: /* a_body: optname PROCESS '(' sign_list ')' p_decl opt_is BEGN doindent rem IF exprc THEN doindent p_body unindent ELSIF edge THEN doindent p_body unindent END IF ';' END PROCESS oname ';' unindent a_body  */
#line 1405 "vhd2vl.y"
                                                 {
           slist *sl;
             if (0) fprintf(stderr,"process style 3: if then elsif then end if\n");
             sl=add_always((yyvsp[-30].sl),(yyvsp[-27].sl),(yyvsp[-25].sl),1);
             if((yyvsp[-21].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-21].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[-19].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-16].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[-10].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3520 "vhd2vl.tab.c"
    break;

  case 69: /* a_body: optname PROCESS '(' sign_list ')' p_decl opt_is BEGN doindent rem IF exprc THEN doindent p_body unindent ELSE IF edge THEN doindent p_body unindent END IF ';' END IF ';' END PROCESS oname ';' unindent a_body  */
#line 1432 "vhd2vl.y"
                                                 {
           slist *sl;
             if (0) fprintf(stderr,"process style 4: if then else if then end if\n");
             sl=add_always((yyvsp[-34].sl),(yyvsp[-31].sl),(yyvsp[-29].sl),1);
             if((yyvsp[-25].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-25].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[-23].sl)); /* exprc */
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-20].sl)); /* p_body:1 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[-13].sl)); /* p_body:2 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3547 "vhd2vl.tab.c"
    break;

  case 70: /* a_body: gen_optname IF exprc generate doindent a_body unindent endgenerate oname ';' a_body  */
#line 1457 "vhd2vl.y"
                                                                                               {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[-10].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"if (");
           sl=addsl(sl,(yyvsp[-8].sl)); /* exprc */
           sl=addtxt(sl,") begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3576 "vhd2vl.tab.c"
    break;

  case 71: /* a_body: gen_optname FOR signal IN expr TO expr generate doindent a_body unindent endgenerate oname ';' a_body  */
#line 1482 "vhd2vl.y"
                                                                                                                 {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3619 "vhd2vl.tab.c"
    break;

  case 72: /* a_body: gen_optname FOR signal IN expr DOWNTO expr generate doindent a_body unindent endgenerate oname ';' a_body  */
#line 1521 "vhd2vl.y"
                                                                                                                     {
         slist *sl;
           blknamelist* tname_list;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3661 "vhd2vl.tab.c"
    break;

  case 73: /* oname: %empty  */
#line 1560 "vhd2vl.y"
        {(yyval.sl)=NULL;}
#line 3667 "vhd2vl.tab.c"
    break;

  case 74: /* oname: NAME  */
#line 1561 "vhd2vl.y"
             {free((yyvsp[0].txt)); (yyval.sl)=NULL;}
#line 3673 "vhd2vl.tab.c"
    break;

  case 75: /* optname: rem  */
#line 1564 "vhd2vl.y"
              {(yyval.sl)=(yyvsp[0].sl);}
#line 3679 "vhd2vl.tab.c"
    break;

  case 76: /* optname: rem NAME ':'  */
#line 1565 "vhd2vl.y"
                       {(yyval.sl)=(yyvsp[-2].sl); free((yyvsp[-1].txt));}
#line 3685 "vhd2vl.tab.c"
    break;

  case 77: /* gen_optname: rem  */
#line 1567 "vhd2vl.y"
                  {(yyval.sl)=(yyvsp[0].sl);}
#line 3691 "vhd2vl.tab.c"
    break;

  case 78: /* gen_optname: rem NAME ':'  */
#line 1568 "vhd2vl.y"
                       {
           blknamelist *tname_list;
           tname_list = xmalloc (sizeof(blknamelist));
           tname_list->name = xmalloc(strlen((yyvsp[-1].txt)));
           strcpy(tname_list->name, (yyvsp[-1].txt));
           tname_list->next = blkname_list;
           blkname_list=tname_list;
           (yyval.sl)=(yyvsp[-2].sl);
           free((yyvsp[-1].txt));
         }
#line 3706 "vhd2vl.tab.c"
    break;

  case 79: /* edge: '(' edge ')'  */
#line 1580 "vhd2vl.y"
                    {(yyval.sl)=addwrap("(",(yyvsp[-1].sl),")");}
#line 3712 "vhd2vl.tab.c"
    break;

  case 80: /* edge: NAME '\'' EVENT AND exprc  */
#line 1581 "vhd2vl.y"
                                 {
         push_clkedge((yyvsp[0].sl)->data.sl->data.txt[0]-'0', "name'event and exprc");
       }
#line 3720 "vhd2vl.tab.c"
    break;

  case 81: /* edge: exprc AND NAME '\'' EVENT  */
#line 1584 "vhd2vl.y"
                                 {
         push_clkedge((yyvsp[-4].sl)->data.sl->data.txt[0]-'0', "exprc and name'event");
       }
#line 3728 "vhd2vl.tab.c"
    break;

  case 82: /* edge: POSEDGE '(' NAME ')'  */
#line 1587 "vhd2vl.y"
                            {
         push_clkedge(1, "explicit");
       }
#line 3736 "vhd2vl.tab.c"
    break;

  case 83: /* edge: NEGEDGE '(' NAME ')'  */
#line 1590 "vhd2vl.y"
                            {
         push_clkedge(0, "explicit");
       }
#line 3744 "vhd2vl.tab.c"
    break;

  case 84: /* yeswith: %empty  */
#line 1595 "vhd2vl.y"
          {dowith=1;}
#line 3750 "vhd2vl.tab.c"
    break;

  case 85: /* with_list: with_item ';'  */
#line 1597 "vhd2vl.y"
                          {(yyval.sl)=(yyvsp[-1].sl);}
#line 3756 "vhd2vl.tab.c"
    break;

  case 86: /* with_list: with_item ',' rem with_list  */
#line 1598 "vhd2vl.y"
                                        {
            slist *sl;
              if((yyvsp[-1].sl)){
                sl=addsl((yyvsp[-3].sl),(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else
                (yyval.sl)=addsl((yyvsp[-3].sl),(yyvsp[0].sl));
            }
#line 3769 "vhd2vl.tab.c"
    break;

  case 87: /* with_list: expr delay WHEN OTHERS ';'  */
#line 1606 "vhd2vl.y"
                                       {
            slist *sl;
              sl=addtxt(indents[indent],"    default : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[-3].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[-3].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[-4].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[-4].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[-4].e)->sl);
              free((yyvsp[-4].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            }
#line 3792 "vhd2vl.tab.c"
    break;

  case 88: /* with_item: expr delay WHEN wlist  */
#line 1625 "vhd2vl.y"
                                  {
            slist *sl;
              sl=addtxt(indents[indent],"    ");
              sl=addsl(sl,(yyvsp[0].sl));
              sl=addtxt(sl," : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[-2].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[-2].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[-3].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[-3].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[-3].e)->sl);
              free((yyvsp[-3].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            }
#line 3817 "vhd2vl.tab.c"
    break;

  case 89: /* p_decl: rem  */
#line 1646 "vhd2vl.y"
             {(yyval.sl)=(yyvsp[0].sl);}
#line 3823 "vhd2vl.tab.c"
    break;

  case 90: /* p_decl: rem VARIABLE s_list ':' type ';' p_decl  */
#line 1647 "vhd2vl.y"
                                                 {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[-6].sl),"    reg");
           sl=addpar(sl,(yyvsp[-2].v));
           free((yyvsp[-2].v));
           sg=(yyvsp[-4].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3848 "vhd2vl.tab.c"
    break;

  case 91: /* p_decl: rem VARIABLE s_list ':' type ':' '=' expr ';' p_decl  */
#line 1667 "vhd2vl.y"
                                                              {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[-9].sl),"    reg");
           sl=addpar(sl,(yyvsp[-5].v));
           free((yyvsp[-5].v));
           sg=(yyvsp[-7].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-2].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3875 "vhd2vl.tab.c"
    break;

  case 92: /* p_body: rem  */
#line 1691 "vhd2vl.y"
             {(yyval.sl)=(yyvsp[0].sl);}
#line 3881 "vhd2vl.tab.c"
    break;

  case 93: /* p_body: rem signal ':' '=' norem expr ';' yesrem p_body  */
#line 1693 "vhd2vl.y"
                                                          {
         slist *sl;
           sl=addsl((yyvsp[-8].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[-7].ss)->sl);
           findothers((yyvsp[-7].ss),(yyvsp[-3].e)->sl);
           sl=addtxt(sl," = ");
           if((yyvsp[-3].e)->op == 'c')
             sl=addsl(sl,addwrap("{",(yyvsp[-3].e)->sl,"}"));
           else
             sl=addsl(sl,(yyvsp[-3].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3899 "vhd2vl.tab.c"
    break;

  case 94: /* p_body: rem signal norem '<' '=' sigvalue yesrem p_body  */
#line 1707 "vhd2vl.y"
                                                          {
         slist *sl;
         sglist *sg;
         char *s;

           s=sbottom((yyvsp[-6].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           sl=addsl((yyvsp[-7].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[-6].ss)->sl);
           findothers((yyvsp[-6].ss),(yyvsp[-2].sl));
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-2].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3922 "vhd2vl.tab.c"
    break;

  case 95: /* p_body: rem IF exprc THEN doindent p_body unindent elsepart END IF ';' p_body  */
#line 1726 "vhd2vl.y"
                                                                               {
         slist *sl;
           sl=addsl((yyvsp[-11].sl),indents[indent]);
           sl=addtxt(sl,"if(");
           sl=addsl(sl,(yyvsp[-9].sl));
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,(yyvsp[-6].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,(yyvsp[-4].sl));
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3939 "vhd2vl.tab.c"
    break;

  case 96: /* p_body: rem FOR signal IN expr TO expr LOOP doindent p_body unindent END LOOP ';' p_body  */
#line 1739 "vhd2vl.y"
                                                                                           {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin\n");
           sl=addsl(sl,(yyvsp[-5].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* p_body:2 */
         }
#line 3965 "vhd2vl.tab.c"
    break;

  case 97: /* p_body: rem FOR signal IN expr DOWNTO expr LOOP doindent p_body unindent END LOOP ';' p_body  */
#line 1761 "vhd2vl.y"
                                                                                               {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[-5].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* p_body:2 */
         }
#line 3991 "vhd2vl.tab.c"
    break;

  case 98: /* p_body: rem CASE signal IS rem cases END CASE ';' p_body  */
#line 1783 "vhd2vl.y"
                                                          {
         slist *sl;
           sl=addsl((yyvsp[-9].sl),indents[indent]);
           sl=addtxt(sl,"case(");
           sl=addsl(sl,(yyvsp[-7].ss)->sl); /* signal */
           sl=addtxt(sl,")\n");
           if((yyvsp[-5].sl)){
             sl=addsl(sl,indents[indent]);
             sl=addsl(sl,(yyvsp[-5].sl));
           }
           sl=addsl(sl,(yyvsp[-4].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endcase\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 4011 "vhd2vl.tab.c"
    break;

  case 99: /* p_body: rem EXIT ';' p_body  */
#line 1798 "vhd2vl.y"
                             {
         slist *sl;
           sl=addsl((yyvsp[-3].sl),indents[indent]);
           sl=addtxt(sl,"disable;  //VHD2VL: add block name here\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 4022 "vhd2vl.tab.c"
    break;

  case 100: /* p_body: rem NULLV ';' p_body  */
#line 1804 "vhd2vl.y"
                              {
         slist *sl;
           if((yyvsp[-3].sl)){
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }else
             (yyval.sl)=(yyvsp[0].sl);
         }
#line 4035 "vhd2vl.tab.c"
    break;

  case 101: /* elsepart: %empty  */
#line 1814 "vhd2vl.y"
           {(yyval.sl)=NULL;}
#line 4041 "vhd2vl.tab.c"
    break;

  case 102: /* elsepart: ELSIF exprc THEN doindent p_body unindent elsepart  */
#line 1815 "vhd2vl.y"
                                                              {
           slist *sl;
             sl=addtxt(indents[indent],"else if(");
             sl=addsl(sl,(yyvsp[-5].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4056 "vhd2vl.tab.c"
    break;

  case 103: /* elsepart: ELSE doindent p_body unindent  */
#line 1825 "vhd2vl.y"
                                         {
           slist *sl;
             sl=addtxt(indents[indent],"else begin\n");
             sl=addsl(sl,(yyvsp[-1].sl));
             sl=addsl(sl,indents[indent]);
             (yyval.sl)=addtxt(sl,"end\n");
           }
#line 4068 "vhd2vl.tab.c"
    break;

  case 104: /* cases: WHEN wlist '=' '>' doindent p_body unindent cases  */
#line 1834 "vhd2vl.y"
                                                         {
        slist *sl;
          sl=addsl(indents[indent],(yyvsp[-6].sl));
          sl=addtxt(sl," : begin\n");
          sl=addsl(sl,(yyvsp[-2].sl));
          sl=addsl(sl,indents[indent]);
          sl=addtxt(sl,"end\n");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4082 "vhd2vl.tab.c"
    break;

  case 105: /* cases: WHEN OTHERS '=' '>' doindent p_body unindent  */
#line 1843 "vhd2vl.y"
                                                     {
        slist *sl;
          sl=addtxt(indents[indent],"default : begin\n");
          sl=addsl(sl,(yyvsp[-1].sl));
          sl=addsl(sl,indents[indent]);
          (yyval.sl)=addtxt(sl,"end\n");
        }
#line 4094 "vhd2vl.tab.c"
    break;

  case 106: /* cases: %empty  */
#line 1850 "vhd2vl.y"
                    { (yyval.sl)=NULL; }
#line 4100 "vhd2vl.tab.c"
    break;

  case 107: /* wlist: wvalue  */
#line 1853 "vhd2vl.y"
               {(yyval.sl)=(yyvsp[0].sl);}
#line 4106 "vhd2vl.tab.c"
    break;

  case 108: /* wlist: wlist '|' wvalue  */
#line 1854 "vhd2vl.y"
                         {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl),",");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4116 "vhd2vl.tab.c"
    break;

  case 109: /* wvalue: STRING  */
#line 1861 "vhd2vl.y"
                {(yyval.sl)=addvec(NULL,(yyvsp[0].txt));}
#line 4122 "vhd2vl.tab.c"
    break;

  case 110: /* wvalue: NAME STRING  */
#line 1862 "vhd2vl.y"
                     {(yyval.sl)=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));}
#line 4128 "vhd2vl.tab.c"
    break;

  case 111: /* wvalue: NAME  */
#line 1863 "vhd2vl.y"
              {(yyval.sl)=addtxt(NULL,(yyvsp[0].txt));}
#line 4134 "vhd2vl.tab.c"
    break;

  case 112: /* sign_list: signal  */
#line 1866 "vhd2vl.y"
                   {(yyval.sl)=(yyvsp[0].ss)->sl; free((yyvsp[0].ss));}
#line 4140 "vhd2vl.tab.c"
    break;

  case 113: /* sign_list: signal ',' sign_list  */
#line 1867 "vhd2vl.y"
                                 {
            slist *sl;
              sl=addtxt((yyvsp[-2].ss)->sl," or ");
              free((yyvsp[-2].ss));
              (yyval.sl)=addsl(sl,(yyvsp[0].sl));
            }
#line 4151 "vhd2vl.tab.c"
    break;

  case 114: /* sigvalue: expr delay ';'  */
#line 1875 "vhd2vl.y"
                          {
           slist *sl;
             if(delay && (yyvsp[-1].n)){
               sl=addtxt(NULL,"# ");
               sl=addval(sl,(yyvsp[-1].n));
               sl=addtxt(sl," ");
             } else
               sl=NULL;
             if((yyvsp[-2].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[-2].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[-2].e)->sl);
             free((yyvsp[-2].e));
             delay=1;
             (yyval.sl)=sl;
           }
#line 4172 "vhd2vl.tab.c"
    break;

  case 115: /* sigvalue: expr delay WHEN exprc ';'  */
#line 1891 "vhd2vl.y"
                                     {
             fprintf(stderr,"Warning on line %d: Can't translate 'expr delay WHEN exprc;' expressions\n",lineno);
             (yyval.sl)=NULL;
           }
#line 4181 "vhd2vl.tab.c"
    break;

  case 116: /* sigvalue: expr delay WHEN exprc ELSE nodelay sigvalue  */
#line 1895 "vhd2vl.y"
                                                       {
           slist *sl;
             sl=addtxt((yyvsp[-3].sl)," ? ");
             if((yyvsp[-6].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[-6].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[-6].e)->sl);
             free((yyvsp[-6].e));
             sl=addtxt(sl," : ");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4197 "vhd2vl.tab.c"
    break;

  case 117: /* nodelay: %empty  */
#line 1908 "vhd2vl.y"
                       {delay=0;}
#line 4203 "vhd2vl.tab.c"
    break;

  case 118: /* delay: %empty  */
#line 1911 "vhd2vl.y"
                       {(yyval.n)=0;}
#line 4209 "vhd2vl.tab.c"
    break;

  case 119: /* delay: AFTER NATURAL NAME  */
#line 1912 "vhd2vl.y"
                              {
             set_timescale((yyvsp[0].txt));
             (yyval.n)=(yyvsp[-1].n);
           }
#line 4218 "vhd2vl.tab.c"
    break;

  case 120: /* map_list: rem map_item  */
#line 1918 "vhd2vl.y"
                        {
           slist *sl;
           sl=addsl((yyvsp[-1].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 4227 "vhd2vl.tab.c"
    break;

  case 121: /* map_list: rem map_item ',' map_list  */
#line 1922 "vhd2vl.y"
                                     {
           slist *sl;
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4239 "vhd2vl.tab.c"
    break;

  case 122: /* map_item: mvalue  */
#line 1931 "vhd2vl.y"
                  {(yyval.sl)=(yyvsp[0].sl);}
#line 4245 "vhd2vl.tab.c"
    break;

  case 123: /* map_item: NAME '=' '>' mvalue  */
#line 1932 "vhd2vl.y"
                               {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[-3].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[0].sl));
             (yyval.sl)=addtxt(sl,")");
           }
#line 4258 "vhd2vl.tab.c"
    break;

  case 124: /* mvalue: STRING  */
#line 1942 "vhd2vl.y"
                {(yyval.sl)=addvec(NULL,(yyvsp[0].txt));}
#line 4264 "vhd2vl.tab.c"
    break;

  case 125: /* mvalue: signal  */
#line 1943 "vhd2vl.y"
                {(yyval.sl)=addsl(NULL,(yyvsp[0].ss)->sl);}
#line 4270 "vhd2vl.tab.c"
    break;

  case 126: /* mvalue: NATURAL  */
#line 1944 "vhd2vl.y"
                 {(yyval.sl)=addval(NULL,(yyvsp[0].n));}
#line 4276 "vhd2vl.tab.c"
    break;

  case 127: /* mvalue: NAME STRING  */
#line 1945 "vhd2vl.y"
                     {(yyval.sl)=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));}
#line 4282 "vhd2vl.tab.c"
    break;

  case 128: /* mvalue: OPEN  */
#line 1946 "vhd2vl.y"
              {(yyval.sl)=addtxt(NULL,"/* open */");}
#line 4288 "vhd2vl.tab.c"
    break;

  case 129: /* mvalue: '(' OTHERS '=' '>' STRING ')'  */
#line 1947 "vhd2vl.y"
                                       {
             (yyval.sl)=addtxt(NULL,"{broken{");
             (yyval.sl)=addtxt((yyval.sl),(yyvsp[-1].txt));
             (yyval.sl)=addtxt((yyval.sl),"}}");
             fprintf(stderr,"Warning on line %d: broken width on port with OTHERS\n",lineno);
           }
#line 4299 "vhd2vl.tab.c"
    break;

  case 130: /* generic_map_list: rem generic_map_item  */
#line 1956 "vhd2vl.y"
                                        {
           slist *sl;
           sl=addsl((yyvsp[-1].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 4308 "vhd2vl.tab.c"
    break;

  case 131: /* generic_map_list: rem generic_map_item ',' generic_map_list  */
#line 1960 "vhd2vl.y"
                                                     {
           slist *sl;
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4320 "vhd2vl.tab.c"
    break;

  case 132: /* generic_map_list: rem expr  */
#line 1967 "vhd2vl.y"
                    {  /* only allow a single un-named map item */
             (yyval.sl)=addsl(NULL,(yyvsp[0].e)->sl);
           }
#line 4328 "vhd2vl.tab.c"
    break;

  case 133: /* generic_map_item: NAME '=' '>' expr  */
#line 1972 "vhd2vl.y"
                                     {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[-3].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[0].e)->sl);
             (yyval.sl)=addtxt(sl,")");
           }
#line 4341 "vhd2vl.tab.c"
    break;

  case 134: /* signal: NAME  */
#line 1982 "vhd2vl.y"
              {
         slist *sl;
         slval *ss;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[0].txt));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->val=-1;
           ss->range=NULL;
           (yyval.ss)=ss;
         }
#line 4360 "vhd2vl.tab.c"
    break;

  case 135: /* signal: NAME '(' vec_range ')'  */
#line 1996 "vhd2vl.y"
                                {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[-3].txt));
           sl=addpar_snug(sl,(yyvsp[-1].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[-1].v);
           if((yyvsp[-1].v)->vtype==tVRANGE) {
             if (0) {
               fprintf(stderr,"ss->val set to 1 for ");
               fslprint(stderr,ss->sl);
               fprintf(stderr,", why?\n");
             }
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         }
#line 4389 "vhd2vl.tab.c"
    break;

  case 136: /* signal: NAME '(' vec_range ')' '(' vec_range ')'  */
#line 2020 "vhd2vl.y"
                                                  {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[-6].txt));
           sl=addpar_snug2(sl,(yyvsp[-4].v), (yyvsp[-1].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[-4].v);
           if((yyvsp[-4].v)->vtype==tVRANGE) {
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         }
#line 4413 "vhd2vl.tab.c"
    break;

  case 137: /* expr: signal  */
#line 2042 "vhd2vl.y"
              {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=(yyvsp[0].ss)->sl;
           free((yyvsp[0].ss));
           (yyval.e)=e;
         }
#line 4426 "vhd2vl.tab.c"
    break;

  case 138: /* expr: STRING  */
#line 2050 "vhd2vl.y"
              {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec(NULL,(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4438 "vhd2vl.tab.c"
    break;

  case 139: /* expr: FLOAT  */
#line 2057 "vhd2vl.y"
             {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addtxt(NULL,(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4449 "vhd2vl.tab.c"
    break;

  case 140: /* expr: NATURAL  */
#line 2063 "vhd2vl.y"
               {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addval(NULL,(yyvsp[0].n));
           (yyval.e)=e;
         }
#line 4460 "vhd2vl.tab.c"
    break;

  case 141: /* expr: NATURAL BASED  */
#line 2069 "vhd2vl.y"
                     {  /* e.g. 16#55aa# */
         /* XXX unify this code with addvec_base */
         expdata *e=xmalloc(sizeof(expdata));
         char *natval = xmalloc(strlen((yyvsp[0].txt))+34);
           e->op='t'; /* Terminal symbol */
           switch((yyvsp[-1].n)) {
           case  2:
             sprintf(natval, "'B%s",(yyvsp[0].txt));
             break;
           case  8:
             sprintf(natval, "'O%s",(yyvsp[0].txt));
             break;
           case 10:
             sprintf(natval, "'D%s",(yyvsp[0].txt));
             break;
           case 16:
             sprintf(natval, "'H%s",(yyvsp[0].txt));
             break;
           default:
             sprintf(natval,"%d#%s#",(yyvsp[-1].n),(yyvsp[0].txt));
             fprintf(stderr,"Warning on line %d: Can't translate based number %s (only bases of 2, 8, 10, and 16 are translatable)\n",lineno,natval);
           }
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         }
#line 4490 "vhd2vl.tab.c"
    break;

  case 142: /* expr: NAME STRING  */
#line 2094 "vhd2vl.y"
                   {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4501 "vhd2vl.tab.c"
    break;

  case 143: /* expr: '(' OTHERS '=' '>' STRING ')'  */
#line 2100 "vhd2vl.y"
                                     {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='o'; /* others */
           e->sl=addothers(NULL,(yyvsp[-1].txt));
           (yyval.e)=e;
         }
#line 4513 "vhd2vl.tab.c"
    break;

  case 144: /* expr: expr '&' expr  */
#line 2107 "vhd2vl.y"
                     { /* Vector chaining */
         slist *sl;
           sl=addtxt((yyvsp[-2].e)->sl,",");
           sl=addsl(sl,(yyvsp[0].e)->sl);
           free((yyvsp[0].e));
           (yyvsp[-2].e)->op='c';
           (yyvsp[-2].e)->sl=sl;
           (yyval.e)=(yyvsp[-2].e);
         }
#line 4527 "vhd2vl.tab.c"
    break;

  case 145: /* expr: '-' expr  */
#line 2116 "vhd2vl.y"
                             {(yyval.e)=addexpr(NULL,'m'," -",(yyvsp[0].e));}
#line 4533 "vhd2vl.tab.c"
    break;

  case 146: /* expr: '+' expr  */
#line 2117 "vhd2vl.y"
                            {(yyval.e)=addexpr(NULL,'p'," +",(yyvsp[0].e));}
#line 4539 "vhd2vl.tab.c"
    break;

  case 147: /* expr: expr '+' expr  */
#line 2118 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'+'," + ",(yyvsp[0].e));}
#line 4545 "vhd2vl.tab.c"
    break;

  case 148: /* expr: expr '-' expr  */
#line 2119 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'-'," - ",(yyvsp[0].e));}
#line 4551 "vhd2vl.tab.c"
    break;

  case 149: /* expr: expr '*' expr  */
#line 2120 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'*'," * ",(yyvsp[0].e));}
#line 4557 "vhd2vl.tab.c"
    break;

  case 150: /* expr: expr '/' expr  */
#line 2121 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'/'," / ",(yyvsp[0].e));}
#line 4563 "vhd2vl.tab.c"
    break;

  case 151: /* expr: expr MOD expr  */
#line 2122 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'%'," % ",(yyvsp[0].e));}
#line 4569 "vhd2vl.tab.c"
    break;

  case 152: /* expr: NOT expr  */
#line 2123 "vhd2vl.y"
                {(yyval.e)=addexpr(NULL,'~'," ~",(yyvsp[0].e));}
#line 4575 "vhd2vl.tab.c"
    break;

  case 153: /* expr: expr AND expr  */
#line 2124 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'&'," & ",(yyvsp[0].e));}
#line 4581 "vhd2vl.tab.c"
    break;

  case 154: /* expr: expr OR expr  */
#line 2125 "vhd2vl.y"
                    {(yyval.e)=addexpr((yyvsp[-2].e),'|'," | ",(yyvsp[0].e));}
#line 4587 "vhd2vl.tab.c"
    break;

  case 155: /* expr: expr XOR expr  */
#line 2126 "vhd2vl.y"
                     {(yyval.e)=addexpr((yyvsp[-2].e),'^'," ^ ",(yyvsp[0].e));}
#line 4593 "vhd2vl.tab.c"
    break;

  case 156: /* expr: expr XNOR expr  */
#line 2127 "vhd2vl.y"
                      {(yyval.e)=addexpr(NULL,'~'," ~",addexpr((yyvsp[-2].e),'^'," ^ ",(yyvsp[0].e)));}
#line 4599 "vhd2vl.tab.c"
    break;

  case 157: /* expr: BITVECT '(' expr ')'  */
#line 2128 "vhd2vl.y"
                            {
       /* single argument type conversion function e.g. std_ulogic_vector(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       if ((yyvsp[-1].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[-1].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       }
       (yyval.e)=e;
      }
#line 4615 "vhd2vl.tab.c"
    break;

  case 158: /* expr: CONVFUNC_2 '(' expr ',' NATURAL ')'  */
#line 2139 "vhd2vl.y"
                                           {
       /* two argument type conversion e.g. to_unsigned(x, 3) */
       (yyval.e) = addnest((yyvsp[-3].e));
      }
#line 4624 "vhd2vl.tab.c"
    break;

  case 159: /* expr: CONVFUNC_2 '(' expr ',' NAME ')'  */
#line 2143 "vhd2vl.y"
                                        {
       (yyval.e) = addnest((yyvsp[-3].e));
      }
#line 4632 "vhd2vl.tab.c"
    break;

  case 160: /* expr: '(' expr ')'  */
#line 2146 "vhd2vl.y"
                    {
       (yyval.e) = addnest((yyvsp[-1].e));
      }
#line 4640 "vhd2vl.tab.c"
    break;

  case 161: /* exprc: conf  */
#line 2152 "vhd2vl.y"
             { (yyval.sl)=(yyvsp[0].sl); }
#line 4646 "vhd2vl.tab.c"
    break;

  case 162: /* exprc: '(' exprc ')'  */
#line 2153 "vhd2vl.y"
                      {
         (yyval.sl)=addwrap("(",(yyvsp[-1].sl),")");
      }
#line 4654 "vhd2vl.tab.c"
    break;

  case 163: /* exprc: exprc AND exprc  */
#line 2156 "vhd2vl.y"
                                   {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl)," && ");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4664 "vhd2vl.tab.c"
    break;

  case 164: /* exprc: exprc OR exprc  */
#line 2161 "vhd2vl.y"
                                 {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl)," || ");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4674 "vhd2vl.tab.c"
    break;

  case 165: /* exprc: NOT exprc  */
#line 2166 "vhd2vl.y"
                             {
        slist *sl;
          sl=addtxt(NULL,"!");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4684 "vhd2vl.tab.c"
    break;

  case 166: /* conf: expr '=' expr  */
#line 2174 "vhd2vl.y"
                                 {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} == ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") == ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," == ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4706 "vhd2vl.tab.c"
    break;

  case 167: /* conf: expr '>' expr  */
#line 2191 "vhd2vl.y"
                     {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} > ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") > ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," > ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4728 "vhd2vl.tab.c"
    break;

  case 168: /* conf: expr '>' '=' expr  */
#line 2208 "vhd2vl.y"
                                     {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} >= ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") >= ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," >= ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4750 "vhd2vl.tab.c"
    break;

  case 169: /* conf: expr '<' expr  */
#line 2225 "vhd2vl.y"
                     {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} < ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") < ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," < ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4772 "vhd2vl.tab.c"
    break;

  case 170: /* conf: expr '<' '=' expr  */
#line 2242 "vhd2vl.y"
                                      {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} <= ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") <= ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," <= ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4794 "vhd2vl.tab.c"
    break;

  case 171: /* conf: expr '/' '=' expr  */
#line 2259 "vhd2vl.y"
                                     {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} != ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") != ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," != ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4816 "vhd2vl.tab.c"
    break;

  case 172: /* simple_expr: signal  */
#line 2278 "vhd2vl.y"
                     {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=(yyvsp[0].ss)->sl;
         free((yyvsp[0].ss));
         (yyval.e)=e;
      }
#line 4829 "vhd2vl.tab.c"
    break;

  case 173: /* simple_expr: STRING  */
#line 2286 "vhd2vl.y"
              {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=addvec(NULL,(yyvsp[0].txt));
         (yyval.e)=e;
      }
#line 4841 "vhd2vl.tab.c"
    break;

  case 174: /* simple_expr: NATURAL  */
#line 2293 "vhd2vl.y"
               {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='n'; /* natural */
         e->value=(yyvsp[0].n);
         e->sl=addval(NULL,(yyvsp[0].n));
         (yyval.e)=e;
      }
#line 4854 "vhd2vl.tab.c"
    break;

  case 175: /* simple_expr: NAME '\'' LEFT  */
#line 2301 "vhd2vl.y"
                      {
	      /* lookup NAME and get its left */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[-2].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[-2].txt));
              }
              if(sg) {
                expdata *e;
                e=xmalloc(sizeof(expdata));
                e->sl=addwrap("(",sg->range->nhi,")");  /* XXX left vs. high? */
                (yyval.e)=e;
              } else {
                fprintf(stderr,"Undefined left \"%s'left\" on line %d\n",(yyvsp[-2].txt),lineno);
                YYABORT;
              }
      }
#line 4875 "vhd2vl.tab.c"
    break;

  case 176: /* simple_expr: simple_expr '+' simple_expr  */
#line 2317 "vhd2vl.y"
                                   {
       (yyval.e)=addexpr((yyvsp[-2].e),'+'," + ",(yyvsp[0].e));
      }
#line 4883 "vhd2vl.tab.c"
    break;

  case 177: /* simple_expr: simple_expr '-' simple_expr  */
#line 2320 "vhd2vl.y"
                                   {
       (yyval.e)=addexpr((yyvsp[-2].e),'-'," - ",(yyvsp[0].e));
      }
#line 4891 "vhd2vl.tab.c"
    break;

  case 178: /* simple_expr: simple_expr '*' simple_expr  */
#line 2323 "vhd2vl.y"
                                   {
       (yyval.e)=addexpr((yyvsp[-2].e),'*'," * ",(yyvsp[0].e));
      }
#line 4899 "vhd2vl.tab.c"
    break;

  case 179: /* simple_expr: simple_expr '/' simple_expr  */
#line 2326 "vhd2vl.y"
                                   {
       (yyval.e)=addexpr((yyvsp[-2].e),'/'," / ",(yyvsp[0].e));
      }
#line 4907 "vhd2vl.tab.c"
    break;

  case 180: /* simple_expr: CONVFUNC_1 '(' simple_expr ')'  */
#line 2329 "vhd2vl.y"
                                      {
       /* one argument type conversion e.g. conv_integer(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       (yyval.e)=e;
      }
#line 4919 "vhd2vl.tab.c"
    break;

  case 181: /* simple_expr: '(' simple_expr ')'  */
#line 2336 "vhd2vl.y"
                           {
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       (yyval.e)=e;
      }
#line 4930 "vhd2vl.tab.c"
    break;


#line 4934 "vhd2vl.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2344 "vhd2vl.y"


const char *outfile;    /* Output file */
const char *sourcefile; /* Input file */

int main(int argc, char *argv[]){
int i,j;
char *s;
slist *sl;
int status;

  /* Init the indentation variables */
  indents[0]=NULL;
  for(i=1;i<MAXINDENT;i++){
    indents[i]=sl=xmalloc(sizeof(slist));
    sl->data.txt=s=xmalloc(sizeof(char) *((i<<1)+1));
    for(j=0;j<(i<<1);j++)
      *s++=' ';
    *s=0;
    sl->type=1;
    sl->slst=NULL;
  }
  if (argc >= 2 && strcmp(argv[1], "--help") == 0) {
    printf(
      "Usage: vhd2vl [-d] [-g1995|-g2001] source_file.vhd > target_file.v\n"
      "   or  vhd2vl [-d] [-g1995|-g2001] source_file.vhd target_file.v\n");
    exit(EXIT_SUCCESS);
  }

  while (argc >= 2) {
     if (strcmp(argv[1], "-d") == 0) {
       yydebug = 1;
     } else if (strcmp(argv[1], "-g1995") == 0) {
       vlog_ver = 0;
     } else if (strcmp(argv[1], "-g2001") == 0) {
       vlog_ver = 1;
     } else {
       break;
     }
     argv++;
     argc--;
  }
  if (argc>=2) {
     sourcefile = argv[1];
     if (strcmp(sourcefile,"-")!=0 && !freopen(sourcefile, "r", stdin)) {
        fprintf(stderr, "Error: Can't open input file '%s'\n", sourcefile);
        return(1);
     }
  } else {
     sourcefile = "-";
  }

  if (argc>=3) {
     outfile = argv[2];
     if (strcmp(outfile,"-")!=0 && !freopen(outfile, "w", stdout)) {
        fprintf(stderr, "Error: Can't open output file '%s'\n", outfile);
        return(1);
     }
  } else {
     outfile = "-";
  }

  printf("// File %s translated with vhd2vl v2.5 VHDL to Verilog RTL translator\n", sourcefile);
  printf("// vhd2vl settings:\n"
         "//  * Verilog Module Declaration Style: %s\n\n",
         vlog_ver ? "2001" : "1995");
  fputs(
"// vhd2vl is Free (libre) Software:\n"
"//   Copyright (C) 2001 Vincenzo Liguori - Ocean Logic Pty Ltd\n"
"//     http://www.ocean-logic.com\n"
"//   Modifications Copyright (C) 2006 Mark Gonzales - PMC Sierra Inc\n"
"//   Modifications (C) 2010 Shankar Giri\n"
"//   Modifications Copyright (C) 2002, 2005, 2008-2010, 2015 Larry Doolittle - LBNL\n"
"//     http://doolittle.icarus.com/~larry/vhd2vl/\n"
"//\n", stdout);
  fputs(
"//   vhd2vl comes with ABSOLUTELY NO WARRANTY.  Always check the resulting\n"
"//   Verilog for correctness, ideally with a formal verification tool.\n"
"//\n"
"//   You are welcome to redistribute vhd2vl under certain conditions.\n"
"//   See the license (GPLv2) file included with the source for details.\n\n"
"// The result of translation follows.  Its copyright status should be\n"
"// considered unchanged from the original VHDL.\n\n"
  , stdout);
  status = yyparse();
  fclose(stdout);
  fclose(stdin);
  if (status != 0 && strcmp(outfile,"-")!=0) unlink(outfile);
  return status;
}
